#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                     W3PERL LIBRAIRY                            #####
####                                                                #####
####                      (http server)                             #####
####                                                                #####
####    domisse@w3perl.com                   version 01/02/2004     #####
####                                                                #####
####                                                                #####
#########################################################################

require "getopt.pl";
require "ctime.pl";
require "timelocal.pl";

$w3perlcgiurl = "/cgi-bin/w3perl";

&Getopt('cdgijlopqrst');

&ReadParse;


if ($opt_c ne '') {
    $conf_file = $opt_c;
} else {
    $conf_file = "/var/www/cgi-bin/w3perl/config.pl"; # install
}	

if (-f $conf_file) {
    require "$conf_file";
} else {
    print "The ";
    print "default " if ($conf_file =~ /config$plext/);
    print "configuration file $conf_file cannot be found.\n";
    print "Please use the admin to build it or use the '-c' flag to load another one.\n";
    exit;
}

if ($reverse_geo == 1) {
    require "/var/www/cgi-bin/w3perl/netgeo.pl" if ($netgeo == 1);
    require "geoip_free.pl" if ($geoip_free == 1); 
    if ($geoip_free == 1) {
	$GeoIP = Geo::IPfree::new();
	$GeoIP->Faster;
    }
}

#$GeoIP->{cache} 
$pos = rindex($cgipath,"cgi");
$cgiurl = substr($cgipath,$pos-1,length($cgipath));

# Filter except for pagegraph script

if ($0 !~ "pagegraph") {

&securecgi if ($ENV{'REQUEST_METHOD'} eq "GET" && $ENV{'HTTP_REFERER'} !~ /$cgiurl/ && $0 !~ "pagegraph" && $0 !~ "cron-hour");
#&securecgi if ($ENV{'REQUEST_METHOD'} eq "GET" && $ENV{'HTTP_REFERER'} !~ /$cgiurl/ && $0 !~ "pagegraph");

if ($ENV{'REQUEST_METHOD'} eq "GET") {

    if ($opt_y != 1) {
	if ($0 !~ /cron-w3perl/) {
	    print "Content-type: text/html\n\n";
	    if ($0 !~ /cron-hour/ && $opt_n ne '') {
		print "<HTML><HEAD><TITLE>Stats</TITLE></HEAD>\n";
		print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\">\n";
	    }
	}
    }

    &ReadParse;

    if ($0 !~ /cron-hour/) {
	print "<B>" if ($0 =~ /cron-w3perl/);
	print "<I>Computing $0 ....</I><BR>\n";
	print "</B>" if ($0 =~ /cron-w3perl/);
    }

}
}

umask(002);

$backgrd2 = $backgrd;
if ($backgrd =~ /background/i) {
    $backgrd =~ s/BACKGROUND="(.*)"/BACKGROUND="\.\.$dirsep\.\.$dirsep$dirress$dirsep$1"/i if ($background !~ /^\// && $background !~ /^http/);
    $backgrd2 =~ s/BACKGROUND="(.*)"/BACKGROUND="\.\.$dirsep\.\.$dirsep\.\.$dirsep$dirress$dirsep$1"/i if ($background !~ /^\// && $background !~ /^http/);
}

#########################################################################
### Making symbolic links to resources (unix only)
#########################################################################

if ($type_serveur == 0 || $ftp_format == 1) {

# Dir docs

$newfile = $path."docs";
$oldfile = $pathinit."docs";

symlink($oldfile,$newfile) if (!(-l $newfile));

# Dir resources

$newfile = $path."resources";
$oldfile = $pathinit."resources";
	
symlink($oldfile,$newfile) if (!(-l $newfile));

# Dir admin

$newfile = $path."admin";
$oldfile = $pathinit."admin";

symlink($oldfile,$newfile) if (!(-l $newfile));

}

#########################################################################
### Language arrays
#########################################################################

%Lang = ( "uk" , "*LangUK",
	  "fr" , "*LangFR",
	  "sp" , "*LangSP",
	  "it" , "*LangIT",
	  "jp" , "*LangJP",
	  "fi" , "*LangFI",
	  "de" , "*LangDE",
	  "br" , "*LangBR",
	  "pt" , "*LangPT",
	  "hu" , "*LangHU",
	  "nl" , "*LangNL" );

for ($i=0;$i<=$#lang;$i++) {
$tmp = $dirress.$dirsepurl."lang".$dirsepurl.$lang[$i].$plext if ($dirsep eq ".");
$tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext if ($dirsep ne ".");
$tmp = $pathinit.$tmp;
require "$tmp";
}

#################################################################
####                          date                        #######
#################################################################

@days_counter = (0,31,59,90,120,151,181,212,243,273,304,334,365);

@day_of_week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');

%month_of_year = ('Jan','31',
                  'Feb','28',
                  'Mar','31',
                  'Apr','30',
                  'May','31',
                  'Jun','30',
                  'Jul','31',
                  'Aug','31',
                  'Sep','30',
                  'Oct','31',
                  'Nov','30',
                  'Dec','31');

@month_nb = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

%month_equiv = ( 'Jan','01',
                 'Feb','02',
                 'Mar','03',
                 'Apr','04',
                 'May','05',
                 'Jun','06',
                 'Jul','07',
                 'Aug','08',
                 'Sep','09',
                 'Oct','10',
                 'Nov','11',
                 'Dec','12');

$datesyst = &ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
$year = $a if ($year eq '');
$day = "0".$day if (length($day) == 1);
$monthindex = $month_equiv{$month};
$countmonth = $month_equiv{$month};
($hour,$minute,$second) = split(/:/,$hourdate);
$today = $day."/".$month."/".$year;
$fullyear = $year;
$fyear = $fullyear - 10;
$smallyear2_today = int($year/100);
$smallyear_today = $year - $smallyear2_today*100;

if (($year%4 == 0 && $year%100 != 0) || $year%400 == 0) {
    $month_of_year{'Feb'} = "29";
    $bisextil = 1;
}

# Conversion W3C logfile entry

%w3c_struct_logfile = ( 'date','%date',
                        'time','%hour',
			'c-ip','%host',
			'cs-username','%login',
			's-sitename','%null',
			's-computername','%null',
			's-ip','%null',
			's-port','%null',
			'cs-method','%method',
			'cs-uri-stem','%page',
			'cs-uri-query','%query',
			'sc-status','%status',
			'sc-win32-status','%null',
			'sc-bytes','%requetesize',
			'cs-bytes','%null',
			'time-taken','%null',
			'cs-version','%protocol',
			'cs-host','%null',
			'cs(User-Agent)','%agent',
			'cs(Cookie)','%null',
			'cs(Referer)','%referer');

%FailStatusMsgs = (-1,"Could Not Look Up Server",
                   -2,"Could Not Open Socket",
                   -3,"Could Not Bind Socket",
                   -4,"Could Not Connect",
		   000,"Used mostly with UDP traffic",
		   100,"Continue",
		   101,"Switching Protocols",
		   102,"Processing",
		   200,"OK",
		   201,"Created",
		   202,"Accepted",
		   203,"Non-Authoritative Information",
		   204,"No Content",
		   205,"Reset Content",
		   206,"Partial Content",
		   207,"Multi Status",
		   300,"Multiple Choices",
                   301,"Found, But Moved Permanently",
	           302,"Found, But Data Resides Under a Different URL",
	           303,"Method",
		   304,"Not Modified",
		   305,"Use Proxy",
		   307,"Temporary Redirect",
	           400,"Bad Request",
	           401,"Unauthorized",
	           402,"Payment Required",
	           403,"Forbidden",
	           404,"Not Found",
		   405,"Method Not Allowed",
		   406,"Not Acceptable",
		   407,"Proxy Authentication Required",
		   408,"Request Timeout",
		   409,"Conflict",
		   410,"Gone",
		   411,"Length Required",
		   412,"Precondition Failed",
		   413,"Request Entity Too Large",
		   414,"Request-URI Too Long",
		   415,"Unsupported Media Type",
		   416,"Requested Range Not Satisfiable",
		   417,"Expectation Failed",
		   424,"Failed Dependency",
		   433,"Unprocessable Entity",
          	   500,"Internal Server Error",
          	   501,"Not Implemented",
          	   502,"Bad Gateway",
          	   503,"Service Unavailable",
		   504,"Gateway Timeout",
		   505,"HTTP Version Not Supported",
		   507,"Insufficient Storage",
		   600,"Squid header parsing error");

#          	   600,"Bad Request",
#		   601,"Not Implemented",
#          	   602,"Connection Failed",
#          	   603,"Timed Out");

%code_info_tcp_udp = ("TCP_HIT","A valid copy of the requested object was in the cache",
		      "TCP_MISS","The requested object was not in the cache",
		      "TCP_REFRESH_HIT","The requested object was cached but STALE. The IMS query for the object resulted in \"304 not modified\"",
		      "TCP_REF_FAIL_HIT","The requested object was cached but STALE. The IMS query failed and the stale object was delivered",
		      "TCP_REFRESH_MISS","The requested object was cached but STALE. The IMS query returned the new content",
		      "TCP_CLIENT_REFRESH_MISS", "The client issued a \"no-cache\" pragma, or analogous cache control command. Thus, the cache has to refetch the object",
		      "TCP_IMS_HIT","The client issued an IMS request for an object which was in the cache and fresh",
		      "TCP_SWAPFAIL_MISS"," The object was believed to be in the cache, but could not be accessed",
		      "TCP_NEGATIVE_HIT","Request for a negatively cached object, e.g. \"404 not found\", for which the cache believes to know that it is inaccessible",
		      "TCP_MEM_HIT","A valid copy of the requested object was in the cache and it was in memory, thus avoiding disk accesses",
		      "TCP_DENIED", "Access was denied for this request",
		      "TCP_OFFLINE_HIT","The requested object was retrieved from the cache during offline mode",
		      "UDP_HIT","A valid copy of the requested object was in the cache",
		      "UDP_MISS","The requested object is not in this cache",
		      "UDP_DENIED", "Access was denied for this request",
		      "UDP_INVALID", "An invalid request was received",
		      "UDP_MISS_NOFETCH"," During \"-Y\" startup, or during frequent failures, a cache in hit only mode will return either UDP_HIT or this code. Neighbours will thus only fetch hits",
		      "NONE","Seen with errors and cachemgr requests");

#################################################################
####                         Robot                        #######
#################################################################

%RobotHash   = (
"acme.spider", "Acme.Spider",
"ahoythehomepagefinder", "Ahoy! The Homepage Finder",
"alkaline", "Alkaline",
"appie", "Walhello appie",
"arachnophilia", "Arachnophilia",
"architext", "ArchitextSpider",
"aretha", "Aretha",
"ariadne", "ARIADNE",
"aspider", "ASpider (Associative Spider)",
"atn.txt", "ATN Worldwide",
"atomz", "Atomz.com Search Robot",
"auresys", "AURESYS",
"backrub", "BackRub",
"bigbrother", "Big Brother",
"bjaaland", "Bjaaland",
"blackwidow", "BlackWidow",
"blindekuh", "Die Blinde Kuh",
"bloodhound", "Bloodhound",
"brightnet", "bright.net caching robot",
"bspider", "BSpider",
"cactvschemistryspider", "CACTVS Chemistry Spider",
"calif", "Calif",
"cassandra", "Cassandra",
"cgireader", "Digimarc Marcspider/CGI",
"checkbot", "Checkbot",
"churl", "churl",
"cmc", "CMC/0.01",
"collective", "Collective",
"combine", "Combine System",
"conceptbot", "Conceptbot",
"core", "Web Core / Roots",
"cshkust", "CS-HKUST WISE: WWW Index and Search Engine",
"cusco", "Cusco",
"cyberspyder", "CyberSpyder Link Test",
"deweb", "DeWeb(c) Katalog/Index",
"dienstspider", "DienstSpider",
"diibot", "Digital Integrity Robot",
"direct_hit", "Direct Hit Grabber",
"dnabot", "DNAbot",
"download_express", "DownLoad Express",
"dragonbot", "DragonBot",
"dwcp", "DWCP (Dridus' Web Cataloging Project)",
"ebiness", "EbiNess",
"eit", "EIT Link Verifier Robot",
"emacs", "Emacs-w3 Search Engine",
"emcspider", "ananzi",
"esther", "Esther",
"evliyacelebi", "Evliya Celebi",
"nzexplorer", "nzexplorer",
"fdse", "Fluid Dynamics Search Engine robot",
"felix", "	Felix IDE",
"ferret", "Wild Ferret Web Hopper #1, #2, #3",
"fetchrover", "FetchRover",
"fido", "fido",
"finnish", "Hmhkki",
"fireball", "KIT-Fireball",
"fish", "Fish search",
"fouineur", "Fouineur",
"francoroute", "Robot Francoroute",
"freecrawl", "Freecrawl",
"funnelweb", "FunnelWeb",
"gazz", "gazz",
"gcreep", "GCreep",
"getbot", "GetBot",
"geturl", "GetURL",
"golem", "Golem",
"googlebot", "Googlebot",
"grapnel", "Grapnel/0.01 Experiment",
"griffon", "Griffon",
"gromit", "Gromit",
"gulliver", "Northern Light Gulliver",
"hambot", "HamBot",
"harvest", "Harvest",
"havindex", "havIndex",
"hometown", "Hometown Spider Pro",
"wired-digital", "Wired Digital",
"htdig", "ht://Dig",
"htmlgobble", "HTMLgobble",
"hyperdecontextualizer", "Hyper-Decontextualizer",
"ibm", "IBM_Planetwide",
"iconoclast", "Popular Iconoclast",
"ilse", "Ingrid",
"imagelock", "Imagelock ",
"incywincy", "IncyWincy",
"informant", "Informant",
"infoseek", "InfoSeek Robot 1.0",
"infoseeksidewinder", "Infoseek Sidewinder",
"infospider", "InfoSpiders",
"inspectorwww", "Inspector Web",
"intelliagent", "IntelliAgent",
"iron33", "Iron33",
"israelisearch", "Israeli-search",
"javabee", "JavaBee",
"jcrawler", "JCrawler",
"jeeves", "Jeeves",
"jobot", "Jobot",
"joebot", "JoeBot",
"jubii", "The Jubii Indexing Robot",
"jumpstation", "JumpStation",
"katipo", "Katipo",
"kdd", "KDD-Explorer",
"kilroy", "Kilroy",
"ko_yappo_robot", "KO_Yappo_Robot",
"labelgrabber.txt", "LabelGrabber",
"larbin", "larbin",
"legs", "legs",
"linkscan", "LinkScan",
"linkwalker", "LinkWalker",
"lockon", "Lockon",
"logo_gif", "logo.gif Crawler",
"lycos", "Lycos",
"macworm", "Mac WWWWorm",
"magpie", "Magpie",
"mediafox", "MediaFox",
"merzscope", "MerzScope",
"meshexplorer", "		NEC-MeshExplorer",
"mindcrawler", "MindCrawler",
"moget", "moget",
"momspider", "MOMspider",
"monster", "Monster",
"motor", "Motor",
"muscatferret", "Muscat Ferret",
"mwdsearch", "Mwd.Search",
"myweb", "Internet Shinchakubin",
"netcarta", "NetCarta WebMap Engine",
"netmechanic", "NetMechanic",
"netscoop", "NetScoop",
"newscan-online", "newscan-online",
"nhse", "NHSE Web Forager",
"nomad", "Nomad",
"northstar", "The NorthStar Robot",
"occam", "Occam",
"octopus", "HKU WWW Octopus",
"orb_search", "Orb Search",
"packrat", "Pack Rat",
"pageboy", "PageBoy",
"parasite", "ParaSite",
"patric", "Patric",
"perignator", "The Peregrinator",
"perlcrawler", "PerlCrawler 1.0",
"phantom", "Phantom",
"piltdownman", "PiltdownMan",
"pioneer", "Pioneer",
"pitkow", "html_analyzer",
"pjspider", "Portal Juice Spider",
"pka", "PGP Key Agent",
"plumtreewebaccessor", "PlumtreeWebAccessor ",
"poppi", "Poppi",
"portalb", "PortalB Spider",
"puu", "GetterroboPlus Puu",
"python", "The Python Robot",
"raven", "Raven Search",
"rbse", "RBSE Spider",
"resumerobot", "Resume Robot",
"rhcs", "RoadHouse Crawling System",
"roadrunner", "Road Runner: The ImageScape Robot",
"robbie", "Robbie the Robot",
"robi", "ComputingSite Robi/1.0",
"roverbot", "Roverbot",
"safetynetrobot", "SafetyNet Robot",
"scooter", "Scooter",
"search_au", "Search.Aus-AU.COM",
"searchprocess", "SearchProcess",
"senrigan", "Senrigan",
"sgscout", "SG-Scout",
"shaggy", "ShagSeeker",
"shaihulud", "Shai'Hulud",
"sift", "Sift",
"simbot", "Simmany Robot Ver1.0",
"site-valet", "Site Valet",
"sitegrabber", "Open Text Index Robot",
"sitetech", "SiteTech-Rover",
"slurp", "Inktomi Slurp",
"smartspider", "Smart Spider",
"snooper", "Snooper",
"solbot", "Solbot",
"spanner", "Spanner",
"speedy", "Speedy Spider",
"spider_monkey", "spider_monkey",
"spiderbot", "SpiderBot",
"spiderman", "SpiderMan",
"spry", "Spry Wizard Robot",
"ssearcher", "Site Searcher",
"suke", "Suke",
"sven", "Sven",
"tach_bw", "TACH Black Widow",
"tarantula", "Tarantula",
"tarspider", "tarspider",
"tcl", "Tcl W3 Robot",
"techbot", "TechBOT",
"templeton", "Templeton",
"titin", "TitIn",
"titan", "TITAN",
"tkwww", "The TkWWW Robot",
"tlspider", "TLSpider",
"ucsd", "UCSD Crawl",
"udmsearch", "UdmSearch",
"urlck", "URL Check",
"valkyrie", "Valkyrie",
"victoria", "Victoria",
"visionsearch", "vision-search",
"voyager", "Voyager",
"vwbot", "VWbot",
"w3index", "The NWI Robot",
"w3m2", "W3M2",
"wanderer", "the World Wide Web Wanderer",
"webbandit", "WebBandit Web Spider",
"webcatcher", "WebCatcher",
"webcopy", "WebCopy",
"webfetcher", "webfetcher",
"webfoot", "The Webfoot Robot",
"weblayers", "Weblayers",
"weblinker", "WebLinker",
"webmirror", "WebMirror",
"webmoose", "The Web Moose",
"webquest", "WebQuest",
"webreader", "Digimarc MarcSpider",
"webreaper", "WebReaper",
"websnarf", "Websnarf",
"webspider", "WebSpider",
"webvac", "WebVac",
"webwalk", "webwalk",
"webwalker", "WebWalker",
"webwatch", "WebWatch",
"wget", "Wget",
"whowhere", "WhoWhere Robot",
"wmir", "w3mir",
"wolp", "WebStolperer",
"wombat", "The Web Wombat ",
"worm", "The World Wide Web Worm",
"wwwc", "WWWC Ver 0.2.5",
"wz101", "WebZinger",
"xget", "XGET",
"nederland.zoek", "Nederland.zoek",
"antibot", "Antibot (Not referenced robot)",
"daviesbot", "DaviesBot (Not referenced robot)",
"ezresult",	"Ezresult (Not referenced robot)",
"fast-webcrawler", "Fast-Webcrawler (Not referenced robot)",
"jennybot", "JennyBot (Not referenced robot)",
"justview", "JustView (Not referenced robot)",
"mercator", "Mercator (Not referenced robot)",
"perman surfer", "Perman surfer (Not referenced robot)",
"unlost_web_crawler", "Unlost_Web_Crawler (Not referenced robot)",
"webbase", "WebBase (Not referenced robot)",
"webcompass", "webcompass (Not referenced robot)",
"digout4u", "digout4u (Not referenced robot)",
"echo", "EchO! (Not referenced robot)",
"voila", "Voila (Not referenced robot)",
"boris", "Boris (Not referenced robot)",
"ultraseek", "Ultraseek (Not referenced robot)",
"ia_archiver", "ia_archiver (Not referenced robot)",
"robot", "Unknown robot (Not referenced robot)"
);

#################################################################
####      convert IIS date format to COMMON format        #######
#################################################################

sub date_common {
    local($date1,$date2) = @_;
    local($year,$month,$day,@val);
     
    @val = split(/[\/\.-]/,$date1);

    eval "\$$date_string[1] = $val[0]";
    eval "\$$date_string[2] = $val[1]";
    eval "\$$date_string[3] = $val[2]";

    $day = "0".$day if (length($day) == 1);

    if ($year < 100) {
 	$year = "0".$year if (length($year) == 1);
 	if ($year <= $smallyear_today) {
 	    $year = $smallyear2_today.$year;
 	} else {
 	    $year = eval($smallyear2_today-1).$year;
 	}
    }

    $date1 = $day."/".$month_nb[--$month]."/".$year;
    $date = $date1.":".$date2;
    $date;
}

#################################################################
####                   print flag value                   #######
#################################################################

sub id {
    local($affirmation) = @_;

print STDOUT "Yes\n" if ($affirmation == 1);
print STDOUT "No\n" if ($affirmation == 0);
}

#################################################################
####            compute hour and day format               #######
#################################################################

### entree : time en seconde, sortie : date, datehour et datemisc

sub get_time {
    local($timesec) = @_;
    local($sec,$min,$hour,$day,$monthnumber,$year,$wday,$yday,$isdst);

($sec,$min,$hour,$day,$monthnumber,$year,$wday,$yday,$isdst) = localtime($timesec);
$month = $month_nb[$monthnumber];
$day = "0".$day if (length($day) == 1);
$min = "0".$min if (length($min) == 1);
$hour = "0".$hour if (length($hour) == 1);
$wday = $day_of_week[$wday];
$yday++;
$isdst++;

# $year passe a 100 en 2000 !!!

$year = substr($year,length($year)-2,length($year));
$year = $smallyear2_today.$year;

#$year = '19'.$year if ($year > 95);
#$year = '20'.$year if ($year < 96);

$date = "$day/$month/$year";
$datehour = "$hour:$min:$sec";
$datemisc = "$yday $wday $isdst";
}

#################################################################
####            get date from timelocal                   #######
#################################################################

sub date_squid {
    local($date) = @_;
    local($tmp1);

    $tmp1 = localtime($date);
    (@tmp) = split(/\s+/,$tmp1);
    $tmp[2] = "0".$tmp[2] if ($tmp[2] < 10);
    $date = $tmp[2].$dirsep.$tmp[1].$dirsep.$tmp[4].":".$tmp[3];

    return $date;
    
}

#################################################################
####            compute number of days                    #######
#################################################################

sub nbdayan {
    local($jour) = @_;
    local($dayjour,$monthjour,$yearjour);

    ($dayjour,$monthjour,$yearjour) = split(/[\s+\/]/,$jour);

    $monthjour = $month_equiv{$monthjour};

    $y = $days_counter[$monthjour-1]+$dayjour;
    $y++ if ($monthjour > 2 && $bisextil == 1);
    $y;
}

#################################################################
####      return number of sec from 1st Jan 1970          #######
#################################################################

sub nb_sec_deb {
    local($date) = @_;
    local($jour,$heure,$minute,$seconde,$day,$month,$year,$sec_deb);

    ($jour,$heure,$minute,$seconde) = split(/:/,$date);
    ($day,$month,$year) = split(/\//,$jour);

    $month = $month_equiv{$month}-1;

    $sec_deb = &timelocal($seconde,$minute,$heure,$day,$month,$year);
    return $sec_deb;
}

#################################################################
####            compute number of days from 1970          #######
#################################################################

sub nbday {
    local($jour) = @_;
    local($dayjour,$monthjour,$yearjour,$y);

    ($dayjour,$monthjour,$yearjour) = split(/[\s+\/]/,$jour);

    $monthjour = $month_equiv{$monthjour}-1 if ($monthjour =~ /\w\w\w/);

    $y = &timelocal(0,0,0,$dayjour,$monthjour,$yearjour);
    $y = int($y/86400);

    return($y);
}

#################################################################
####            compute date with intervalle              #######
#################################################################

sub date_intervalle {
    local($jour,$intervalle) = @_;
    local($dayjour,$monthjour,$yearjour,$tmp);

    ($dayjour,$monthjour,$yearjour) = split(/[\s+\/]/,$jour);

    $tmp = $dayjour+$intervalle;

    $countmonth = $month_equiv{$monthjour}-1;
    $dayjour = $dayjour+$intervalle;

    if ($dayjour >  $month_of_year{$monthjour}) {
	$dayjour = $dayjour-$month_of_year{$monthjour};
	$countmonth++;
	$yearjour++ if ($countmonth > 11);
	$countmonth = 0 if ($countmonth > 11);
	$monthjour = $month_nb[$countmonth];
    }
    
    $dayjour = "0".$dayjour if (length($dayjour) == 1);
    
    $date = "$dayjour"."/"."$monthjour"."/"."$yearjour";
    $date =~ s/[\/]/ /g;
    return $date

}

#################################################################
####            Lookup for DNS reverse                    #######
#################################################################

sub reversedns {
    local($adr) = @_;
    local ($a,$b,$c,$d,$tmp);

    $adr = $revdns{$adr} if ($revdns{$adr} ne '');
    if (($adr =~ /^[0-9.]+$/ && $revdns{$adr} eq '')) {
	($a,$b,$c,$d) = split(/\./,$adr);
	$tmp = pack('C4',$a,$b,$c,$d);
	($adresse) = gethostbyaddr($tmp,2);
	$tmp = substr($adresse,rindex($adresse,'.'));
	$adresse = $adr if (($adresse eq '') || $adresse =~ /[0-9]$/ || (length($tmp) < 3));
	$revdns{$adr} = $adresse;
    } else {
    $adresse = $adr;
    }
    return($adresse);
}

#################################################################
####                   GeoIP reverse (Geo::IP)            #######
#################################################################

sub get_geoip {
    local($adr) = @_;
    local ($pays);

    if ($adr =~ /^[0-9.]+$/) {
	my $pays = Geo::IP->new(GEOIP_MEMORY_CACHE); # GEOIP_STANDARD
	return $pays->country_code_by_addr($adr);
    }
}

#################################################################
####                   GeoIP reverse (Geo::IPfree)        #######
#################################################################

sub get_geoipfree {
    local($adr) = @_;
    local ($pays);

    if ($adr =~ /^[0-9.]+$/) {
	my ($pays) = $GeoIP->LookUp($adr) ;
	return $pays;
    }
}


#################################################################
####                Loading DNS table                     #######
#################################################################

sub load_reverse_dns {
	local($ipdata,$tmp);

	print STDOUT "Loading DNS table\n" if ($opt_n eq '' && $ENV{'REQUEST_METHOD'} ne "GET");
	print STDOUT "<BR>" if ($opt_n eq '' && $ENV{'REQUEST_METHOD'} eq "GET");

	open(IP,"$path$dirdata$dirsep$ip_table");
	while (<IP>) {
		chop;
		($ipdata,$tmp) = split(/\t/);
		$revdns{$ipdata} = $tmp;
		}
	close(IP);
}

#################################################################
####                Saving DNS table                      #######
#################################################################

sub save_reverse_dns {
	local($ipdata);
	
	open(IP,">$path$dirdata$dirsep$ip_table");
	foreach $ipdata (keys(%revdns)) {
		print IP "$ipdata\t$revdns{$ipdata}\n";
		}
	close(IP);
}

#################################################################
####         subroutine to compute the tree                 #####
#################################################################

sub row_end {
    local(*FOUT,*L,$temp,$value,$racine,$oldvalue,$coi,$script) = @_;
    local($boucle2,$affrac,$it,$loop,$z,$val,$tmp);

        $boucle2 = $rowboucle{$temp,$racine,$coi};

        $coi++;

        for ($it=1;$it<=$boucle2;$it++) {

        $affrac = $racine;
	$affrac =~ s/\+/\\+/g; # /C++/
#	$affrac =~ s/[\[\]]//g; # remove []

        for ($loop=$coi;$loop<=$maxdepth;$loop++) {

        $match = 0;
        if ($racine ne '') {
             for ($z=1;$z<=$maxrowspan;$z++) {
                if ($depthrac{$temp,$z,$loop} =~ m/$affrac/) {
                   $affrac = $depthrac{$temp,$z,$loop};
#		   $affrac =~ s/[\[\]]//g; # remove []
                   $match = 1;
                   last;
                   }
              }
           }

        $val = $rowspan{$temp,$z,$loop};
        $val = 0 if ($match == 0);

        $temp2 = $affrac;
        $pos2 = rindex($temp2,$dirsepurl,length($temp2)-2);
        $remind = substr($temp2,$pos2,length($temp2));

        print FOUT "<TD";
        print FOUT " ROWSPAN=$val" if ($val != 1 && $val !=0);
#	$toto = 1;
#        print FOUT " COLSPAN=2 " if ($toto == 1);
        print FOUT ">";
        print FOUT "&nbsp;" if ($val == 0);

        if ($val != 0) {
	    $freqracdepth{$affrac} = 0 if ($freqracdepth{$affrac} eq '');
	    $freqrac{$affrac} = 0 if ($freqrac{$affrac} eq '' && $script == 0);
	    $freqracurl{$affrac} = 0 if ($freqracurl{$affrac} eq '' && $script == 1);
	    $frequpdate{$affrac} = 0 if ($frequpdate{$affrac} eq '');

	    if ($freqracurl{$affrac} != 0 && $script == 1) { 
		$tmp = $affrac;
		chop($tmp);
		$tmp = substr($tmp,1,length($tmp));
		$tmp =~ s/\//_/g;
		$tmp = $tmp.$htmlext;
	    }

	    if ($script == 1) {
		$tmp2 = 0;
		for ($l=1;$l<=$count{$affrac};$l++) {
		    $page = $newpageslues{$affrac,$l};
		    $tmp2 += $pageslues{$page};
		}
	    }

	print FOUT "<TABLE BORDER=0 WIDTH=100%><TR><TD ALIGN=CENTER VALIGN=CENTER>&nbsp;\n" if ($script == 1);
        print FOUT "<A HREF=\"$affrac\">$remind</A>" if ($script == 0);
	if ($script == 1) {
	    print FOUT "<A HREF=\"$tmp\">" if ($freqracurl{$affrac} != 0);
	    print FOUT "$remind";
	    print FOUT "</A>" if ($freqracurl{$affrac} != 0);
        }


	if ($script == 1) {
	    if ($freqracurl{$affrac} != 0) {
		print FOUT "&nbsp;</TD></TR><TR><TD ALIGN=CENTER VALIGN=CENTER>";
		print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR>";
		$tmp3 = int(100*$freqracurl{$affrac}/$freqracurltot{$affrac}) if ($freqracurltot{$affrac} != 0);
		$tmp3 = 0 if ($freqracurltot{$affrac} == 0);
		print FOUT "<TD><FONT SIZE=-1>$freqracurl{$affrac}&nbsp;</FONT></TD><TD><FONT SIZE=-1>&nbsp;($tmp3 %)</FONT></TD></TR>\n";
		$tmp3 = int(100*$tmp2/$freq2rachtml{$affrac}) if ($freq2rachtml{$affrac} != 0);
		$tmp3 = 0 if ($freq2rachtml{$affrac} == 0);
		print FOUT "<TR><TD><FONT SIZE=-1>$tmp2&nbsp;</FONT></TD><TD><FONT SIZE=-1>&nbsp;($tmp3 %)</FONT></TD></TR></TABLE>\n";
	    }
	    print FOUT "</TD></TR></TABLE>\n";
	}

	if ($script == 0) {
	    print FOUT "<BR><I>[$freqracdepth{$affrac} - ";
	    print FOUT "$freqracurl{$affrac}" if ($script == 1);
	    print FOUT "$freqrac{$affrac} - $frequpdate{$affrac}" if ($script == 0);
	    print FOUT "]</I>";
	}
        }

        print FOUT "</TD>\n";

        $depthrac{$temp,$z,$loop} = '' if ($match == 1);

        if ($val != 1 && $val !=0) {
           &row_end(*FOUT,*L,$temp,$val,$affrac,$val,$coi,$script);
           $loop = $maxdepth;
           $boucle2 =$rowboucle{$temp,$racine,$coi-1};
           }

        }

        if ($it != $boucle2) {
        print FOUT "</TR>\n\n<TR>\n";
        }

        }
        $i = $maxdepth;
}


#################################################################
####                     Parsing forms                    #######
#################################################################
# Extracted from cgi-lib.pl from S.E.Brenner@bioc.cam.ac.uk


sub ReadParse {
  local (*in) = @_ if @_;
  local ($i, $key, $val);

  # Read in text
  if (&MethGet) {
    $in = $ENV{'QUERY_STRING'};
  } elsif (&MethPost) {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
  }

  @in = split(/[&;]/,$in);

  foreach $i (0 .. $#in) {
    # Convert plus's to spaces
    $in[$i] =~ s/\+/ /g;

    # Split into key and value.
    ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

    # Convert %XX from hex numbers to alphanumeric
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;

    $opt = "opt_$key";
#    $$opt = $val;             # Work only with perl 5 and above
    eval "\$$opt = $val";
    
  }
  $ENV{'QUERY_STRING'} = '';
}

# MethGet
# Return true if this cgi call was using the GET request, false otherwise

sub MethGet {
  return ($ENV{'REQUEST_METHOD'} eq "GET");
}


# MethPost
# Return true if this cgi call was using the POST request, false otherwise

sub MethPost {
  return ($ENV{'REQUEST_METHOD'} eq "POST");
}

#################################################################
####       Parse html pages to replace accent             #######
#################################################################
# remplace les codes accent ascii accent par du html

sub accent2html {
    local($words) = @_;

    $words =~ s//&eacute;/g;
    $words =~ s//&egrave;/g;
    $words =~ s//&ecirc;/g;
    $words =~ s//&euml;/g;


    $words =~ s//&Eacute;/g;
    $words =~ s//&Egrave;/g;
    $words =~ s//&Ecirc;/g;
    $words =~ s//&Euml;/g;


    $words =~ s//&aacute;/g;
    $words =~ s//&agrave;/g;
    $words =~ s//&acirc;/g;
    $words =~ s//&auml;/g;

    $words =~ s//&Aacute;/g;
    $words =~ s//&Agrave;/g;
    $words =~ s//&Acirc;/g;
    $words =~ s//&Auml;/g;


    $words =~ s//&iacute;/g;
    $words =~ s//&igrave;/g;
    $words =~ s//&icirc;/g;
    $words =~ s//&iuml;/g;

    $words =~ s//&Iacute;/g;
    $words =~ s//&Igrave;/g;
    $words =~ s//&Icirc;/g;
    $words =~ s//&Iuml;/g;


    $words =~ s//&oacute;/g;
    $words =~ s//&ograve;/g;
    $words =~ s//&ocirc;/g;
    $words =~ s//&ouml;/g;

    $words =~ s//&Oacute;/g;
    $words =~ s//&Ograve;/g;
    $words =~ s//&Ocirc;/g;
    $words =~ s//&Ouml;/g;


    $words =~ s//&uacute;/g;
    $words =~ s//&ugrave;/g;
    $words =~ s//&ucirc;/g;
    $words =~ s//&uuml;/g;

    $words =~ s//&Uacute;/g;
    $words =~ s//&Ugrave;/g;
    $words =~ s//&Ucirc;/g;
    $words =~ s//&Uuml;/g;


    $words =~ s//&ccedil;/g;
    $words =~ s//&Ccedil;/g;

    return $words;
    
}

# supprime les accents

sub noaccent {
    local($words) = @_;

    $words =~ s//e/g;
    $words =~ s//e/g;
    $words =~ s//e/g;
    $words =~ s//e/g;

    $words =~ s//E/g;
    $words =~ s//E/g;
    $words =~ s//E/g;
    $words =~ s//E/g;

    $words =~ s//a/g;
    $words =~ s//a/g;
    $words =~ s//a/g;
    $words =~ s//a/g;

    $words =~ s//A/g;
    $words =~ s//A/g;
    $words =~ s//A/g;
    $words =~ s//A/g;

    $words =~ s//i/g;
    $words =~ s//i/g;
    $words =~ s//i/g;
    $words =~ s//i/g;

    $words =~ s//I/g;
    $words =~ s//I/g;
    $words =~ s//I/g;
    $words =~ s//I/g;

    $words =~ s//o/g;
    $words =~ s//o/g;
    $words =~ s//o/g;
    $words =~ s//o/g;

    $words =~ s//O/g;
    $words =~ s//O/g;
    $words =~ s//O/g;
    $words =~ s//O/g;

    $words =~ s//u/g;
    $words =~ s//u/g;
    $words =~ s//u/g;
    $words =~ s//u/g;

    $words =~ s//U/g;
    $words =~ s//U/g;
    $words =~ s//U/g;
    $words =~ s//U/g;

    $words =~ s//c/g;
    $words =~ s//C/g;

    return $words;
    
}


#################################################################
####                 Sort data by number                  #######
#################################################################

sub bynumber { 
$a <=> $b;
}

#################################################################
####                 Recursive delete                     #######
#################################################################

sub dodirdel {
    local($dir) = @_;
    local($i,@filenames);

    if (-d $dir) {
	opendir(SOURCEDIR,$dir);
	@filenames = readdir(SOURCEDIR);
	closedir(SOURCEDIR);

	for ($i=0;$i<=$#filenames;$i++) {
	    if (-f "$dir$dirsep$filenames[$i]") {
		unlink("$dir$dirsep$filenames[$i]");
	    }

	    if (-d "$dir$dirsep$filenames[$i]" && $filenames[$i] ne '.' && $filenames[$i] ne '..') {
		chdir "$dir$dirsep$filenames[$i]";
		&dodirdel("$dir$dirsep$filenames[$i]");
		chdir '..';
		rmdir("$dir$dirsep$filenames[$i]");
	    }
	}
    }
}


#################################################################
####            Compute real time running                 #######
#################################################################

sub timetaken {
local($a,$b) = @_;
local($hour1,$hour2,$minute1,$minute2,$sec1,$sec2);
local ($hour,$sec,$min,$tmp);

($hour1,$minute1,$sec1) = split(/:/,$a);
($hour2,$minute2,$sec2) = split(/:/,$b);

$sec1 = $hour1*3600+$minute1*60+$sec1;
$sec2 = $hour2*3600+$minute2*60+$sec2;

$tmp = $sec2-$sec1;
$tmp += 86400  if ($tmp < 0);

$hour = int($tmp/3600);
$min = int(($tmp-($hour*3600))/60);
$sec = $tmp-($hour*3600)-($min*60);

$hour = "0".$hour if (length($hour) == 1);
$min = "0".$min if (length($min) == 1);
$sec = "0".$sec if (length($sec) == 1);

return($hour,$min,$sec);
}

#################################################################
####                   Error debugging                    #######
#################################################################

sub error_open {
    local($file) = @_;
#    print "Content-type: text/html\n\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
#    print "<HTML><HEAD><TITLE>Stats</TITLE></HEAD>\n";
#    print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\">\n";
    print "<P><DIR><FONT COLOR=\"#AA2020\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "Unable to open $file - $!\n";
    print "</FONT><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print " ==> check read permission\n";
    print "</DIR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    exit;
}

#################################################################
####                   yesterday                          #######
#################################################################

sub yesterday_date {
    local($day,$countmonth,$year) = @_;
#    local($month);

    $countmonth--;
    $day--;
    if ($day < 1) {
	$countmonth--;
	$year-- if ($countmonth < 0);
	$countmonth = 11 if ($countmonth < 0);
	$month = $month_nb[$countmonth];
	$day = $month_of_year{$month};
    }
    
    $day = "0".$day if (length($day) == 1);
    
    $yesterday = "$day"."/"."$month"."/"."$year";
    $yesterday =~ s/[\/]/ /g;
    return $yesterday;

}

#################################################################
####                   Check referer cgi                  #######
#################################################################

sub securecgi {
  local($file) = @_;
  local($tmp1,$tmp2);

  print "Content-type: text/html\n\n";
  print "<HTML><HEAD><TITLE>Installation forbidden access</TITLE></HEAD>\n";
  print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\">\n";
  print "<P><BR><H3><CENTER>";
  print "Forbidden access\n";
  print "</H3><P></CENTER><BR>";
  print "<P><DIR><FONT COLOR=\"#AA2020\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
  print "You should run scripts from the interface administration\n";
  print "</FONT><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
  print " This is to avoid unsollicited access to your stats\n";
  print "</DIR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
  exit;
}

#################################################################
####                   Homepage                           #######
#################################################################

sub update_homepage {

#if (!(-f "$path$dirinc$dirsep$incgeneral")) {
#        print STDERR "You should first run once the package !\n";
#        exit;
#        }

if (-f "$path$dirinc$dirsep$incgeneral") {

    print "Updating stats homepage\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
        
# hmmm la il faut recharger les valeurs et les updater !

    open(GENERAL,"$path$dirinc$dirsep$incgeneral") || die "Error, unable to open $path$dirinc$dirsep$incgeneral\n";
    while (<GENERAL>) {
	($date1,$date2,$date3,$reqtot,$reqdomtot,$totsize,$externesize,$domsize,$nbdays,$access,$accessdom,$tothtmlsize,$loglines,$proxy,$redirect,$forbiden,$notfound,$exclpages,$excladdr,$exclframed,$exclrobots,$paysunique) = split;
    }
    close GENERAL;

    $firstday = "$date1"." "."$date2"." "."$date3";

# conversion en Megaoctets

    $totsize /= (1024*1024);
    $externesize /= (1024*1024);
    $domsize /= (1024*1024);

if (-f "$path$dirinc$dirsep$virusdef") {
$nb_virus = 0;
open(VIRUS,"$path$dirinc$dirsep$virusdef");
while (<VIRUS>) {
    chop;
    ($adresse,$tmp1,$tmp2,$tmp3) = split(/\t/);
    if ($tmp3 ne '') {
	$nb_virus++;
    }
}
close VIRUS;
}

# general est charge pour avoir nbdays !

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
        $top = $path.$lang[$nblang].$dirsep.$dirframe.$dirsep.$topframe;
        open(TOP,">$top") || die "Error, unable to open $topframe\n";
        &CreateTopFrame(*TOP, eval($Lang{$lang[$nblang]}), $homepagesframed[$nblang], $lang[$nblang]);
        close (TOP);
    }

    for ($nblang=0;$nblang<=$#lang;$nblang++) {
        $bottom = $path.$lang[$nblang].$dirsep.$dirframe.$dirsep.$bottomframe;
        open(BOTTOM,">$bottom") || die "Error, unable to open $bottom\n";
        &CreateBottomFrame(*BOTTOM, eval($Lang{$lang[$nblang]}), $homepages[$nblang], $lang[$nblang]);
        close (BOTTOM);
    }

    open(PAGESLUES,"$path$dirinc$dirsep$incpage") || die "Error, unable to open $path$dirinc$dirsep$incpage\n";
    while (<PAGESLUES>) {
	$pageunique++;
    }
    close PAGESLUES;

#open(PAYS,"$path$dirinc$dirsep$incpays") || die "Error, unable to open $path$dirinc$dirsep$incpays\n";
#while (<PAYS>) {
#($tmp) = split(/\s+/,$_);
#$paysunique++ if ($tmp ne "Unknown");
#}
#close PAYS;


    if ($ftp_format == 1) {
	open(FTP,"$path$dirinc$dirsep$incftp") || die "Error, unable to open $path$dirinc$dirsep$incftp\n";
	while (<FTP>) {
	    ($totsize_in) = split;
	}
	close(FTP);
	$totsize_in /= (1024*1024);
    }

    open(SERVEXTERNE,"$path$dirinc$dirsep$incservexterne") || die "Error, unable to open $path$dirinc$dirsep$incservexterne\n";
    while (<SERVEXTERNE>) {
	$serverunique++;
    }
    close SERVEXTERNE;
    
    open(SERVINTERNE,"$path$dirinc$dirsep$incservinterne") || die "Error, unable to open $path$dirinc$dirsep$incservinterne\n";
    while (<SERVINTERNE>) {
	$locserver++;
    }
    close SERVINTERNE;

    $serveruniquetot = $serverunique+$locserver;

    if (-f "$path$dirinc$dirsep$incvirtual") {
	open(VIRTUAL,"$path$dirinc$dirsep$incvirtual") || die "Error, unable to open $path$dirinc$dirsep$incvirtual\n";
	while (<VIRTUAL>) {
	    $virtualunique++;
	}
    }
    
    if ($precision == 1) {
	for ($nblang=0;$nblang<=$#lang;$nblang++) {
	    open(LITTLEINDEX,">$path$homepages[$nblang]") || die "Error,  unable to open $path$homepages[$nblang]\n";
	    &CreateLittleIndex(*LITTLEINDEX, eval($Lang{$lang[$nblang]}), $homepages[$nblang], $lang[$nblang], $homepagesframed[$nblang]);
	    close (LITTLEINDEX);
	}
    }
    
    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	$mainindex = $path.$homepages[$nblang];
        $mainindex2 = $path.$lang[$nblang].$dirsep.$dirframe.$dirsep.$homepagesframed[$nblang];
	
        open(MAININDEX,">$mainindex") || die "Error, unable to open $mainindex\n";
        open(MAININDEX2,">$mainindex2") || die "Error, unable to open $mainindex2\n";
        &CreateMainIndex(*MAININDEX,*MAININDEX2, eval($Lang{$lang[$nblang]}), $homepages[$nblang], $lang[$nblang], $homepagesframed[$nblang]);
        close (MAININDEX);
        close (MAININDEX2);
    }
}
}

#################################################################
####                   Homepage                           #######
#################################################################

sub CreateTopFrame {
  local(*FOUT,*L, $H, $I) = @_;

  print FOUT "<HTML><HEAD>\n";
  print FOUT "<TITLE>W3Perl Frames Top : $L{'Language'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - cron-pages.pl $version - $today $hourdate -->\n";
  print FOUT "<META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">";
  print FOUT "<META NAME=\"ROBOTS\" CONTENT=\"NOINDEX\">";
  print FOUT "</HEAD>\n";

  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  print FOUT "<CENTER>\n";
#print FOUT "[<A HREF=\"javascript:history.back()\" TARGET=\"_top\">$L{'Back'}</A> | <A HREF=\"http://$localserver$tri\" TARGET=\"_top\">Homepage</A>] | ";
  
  if ($frame_updown == 1) {
      print FOUT "[";
      print FOUT "$topframelinks";
      print FOUT "] | ";
      print FOUT "[" if ($#lang != 0);
  } else {
      print FOUT "$topframelinks<P><HR><P>";
  }

for ($i=0;$i<=$#lang;$i++) {
print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$homepages[$i]\" TARGET=\"_top\"><IMG BORDER=0 WIDTH=30 HEIGHT=15 SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$flag[$i]\" ALT=\"$flag[$i]\"></A>\n" unless ($I eq $lang[$i]);
print FOUT "| " if (($i != ($#lang) && ($I ne $lang[$i])) && !($lang[$#lang] eq $I && $i == (($#lang)-1)) && ($frame_updown == 1) ); 
print FOUT "<BR>" if ($i != ($#lang) && ($I ne $lang[$i]) && !($lang[$#lang] eq $I && $i == (($#lang)-1)) && ($frame_updown != 1));
}

if ($frame_updown == 1) {
print FOUT "] | " if ($#lang != 0);
print FOUT "[$packagename : ";
print FOUT "<A HREF=\"$H\" TARGET=\"display\">$L{'Index'}</A> - ";
print FOUT "<A HREF=\"http://www.w3perl.com/demo/docs/html/new.html?$version\" TARGET=\"display\">$L{'News'}</A> - ";
print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$linkpathinit$dirdocs$dirsepurl$help\" TARGET=\"display\">$L{'Docs'}</A>]\n";
} else {
print FOUT "<P><HR><P>\n" if ($#lang != 0);
print FOUT "[$packagename]<P>";
print FOUT "<A HREF=\"$H\" TARGET=\"display\"><IMG WIDTH=41 HEIGHT=28 SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$drawstatsmall\" BORDER=0></A><BR>\n";
print FOUT "<A HREF=\"$H\" TARGET=\"display\">$L{'Index'}</A><BR>";
print FOUT "<A HREF=\"http://www.w3perl.com/demo/docs/html/new.html?$version\" TARGET=\"display\"><IMG WIDTH=42 HEIGHT=20 SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$icon_new_w3perl\" BORDER=0></A><BR>\n";
print FOUT "<A HREF=\"http://www.w3perl.com/demo/docs/html/new.html?$version\" TARGET=\"display\">$L{'News'}</A><BR>";
print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$linkpathinit$dirdocs$dirsepurl$help\" TARGET=\"display\"><IMG WIDTH=41 HEIGHT=41 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_info\" BORDER=0></A><BR>\n";
print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$linkpathinit$dirdocs$dirsepurl$help\" TARGET=\"display\">$L{'Docs'}</A>\n";
}

print FOUT "</CENTER>";
print FOUT "</BODY></HTML>";
}


#################################################################
####                   Homepage                           #######
#################################################################

sub CreateBottomFrame {
  local(*FOUT,*L, $H, $I) = @_;

print FOUT "<HTML><HEAD>\n";
print FOUT "<TITLE>W3Perl Frames Bottom: $L{'Language'}</TITLE>\n";
print FOUT "<!-- Page generated by w3perl - cron-pages.pl $version - $today $hourdate -->\n";
print FOUT "<META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">";
print FOUT "<META NAME=\"ROBOTS\" CONTENT=\"NOINDEX\">";
print FOUT "</HEAD>\n";

print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";

print FOUT "<CENTER>\n";

if ($frame_updown == 1) {
print FOUT "[<A HREF=\"..$dirsepurl$dirsite$dirsepurl$filesites\" TARGET=\"display\">$L{'Hosts'}</A> | ";
print FOUT "<A HREF=\"..$dirsepurl$dirpage$dirsepurl$filepages\" TARGET=\"display\">$L{'Pages'}</A>";
print FOUT " | <A HREF=\"..$dirsepurl$dirscript$dirsepurl$filescript\" TARGET=\"display\">$L{'Scripts'}</A>" if ($inc_script == 1);

if ($precision > 2) {
print FOUT " | <A HREF=\"..$dirsepurl$dirlist$dirsepurl$filetype$htmlext\" TARGET=\"display\">$L{'Filetype'}</A> | ";
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filerepert\" TARGET=\"display\">$L{'Directories'}</A> | ";
if ($paysunique != 0) {
print FOUT "<A HREF=\"..$dirsepurl$dirpays$dirsepurl$filepays\" TARGET=\"display\">$L{'Countries'}</A> | ";
}
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$dirdownload$htmlext\" TARGET=\"display\">$L{'Download'}</A> | ";
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$dirtraffic$htmlext\" TARGET=\"display\">$L{'Traffic'}</A>";
}

print FOUT "] | [";
print FOUT "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$file_now\" TARGET=\"display\">$L{'Real_time'}</A> | " if (-e "$path$I$dirsep$dirdate$dirsep$file_now");
print FOUT "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$filehour\" TARGET=\"display\">$L{'Hours'}</A> | " if (-e "$path$I$dirsep$dirdate$dirsep$filenamehour");
print FOUT "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$fileday\" TARGET=\"display\">$L{'Days'}</A>";
print FOUT " | <A HREF=\"..$dirsepurl$dirdate$dirsepurl$fileweek\" TARGET=\"display\">$L{'Weeks'}</A> " unless ($nbdays < 14);
print FOUT " | <A HREF=\"..$dirsepurl$dirdate$dirsepurl$filemonth\" TARGET=\"display\">$L{'Months'}</A> " if ($nbdays > 30 || $count_month > 0);
print FOUT "]\n";

#if ((-e "$path$I$dirsep$dirdocument$dirsep$menu") || (-e "$path$I$dirsep$dirsession$dirsep$filesession") || (-e "$path$I$dirsep$dirlist$dirsep$filevirus") || (-e "$path$I$dirsep$dirlist$dirsep$filevirtual") || (-e "$path$I$dirsep$dirlist$dirsep$error") || (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")) {
if ((-e "$path$I$dirsep$dirdocument$dirsep$menu") || (-e "$path$I$dirsep$dirsession$dirsep$filesession") || ($nb_virus != 0) || (-e "$path$I$dirsep$dirlist$dirsep$filevirtual") || (-e "$path$I$dirsep$dirlist$dirsep$error") || (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")) {
print FOUT "<BR>\n";
print FOUT "[";
print FOUT "<A HREF=\"..$dirsepurl$dirdocument$dirsepurl$menu\" TARGET=\"display\">$L{'Documents'}</A>" if (-e "$path$I$dirsep$dirdocument$dirsep$menu");

#print FOUT " | " if ((-e "$path$I$dirsep$dirdocument$dirsep$menu") && ((-e "$path$I$dirsep$dirsession$dirsep$filesession") || (-e "$path$I$dirsep$dirlist$dirsep$filevirus") || (-e "$path$I$dirsep$dirlist$dirsep$filevirtual") || (-e "$path$I$dirsep$dirlist$dirsep$error") || (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")));
print FOUT " | " if ((-e "$path$I$dirsep$dirdocument$dirsep$menu") && ((-e "$path$I$dirsep$dirsession$dirsep$filesession") || ($nb_virus != 0) || (-e "$path$I$dirsep$dirlist$dirsep$filevirtual") || (-e "$path$I$dirsep$dirlist$dirsep$error") || (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")));

print FOUT "<A HREF=\"..$dirsepurl$dirsession$dirsepurl$filesession\" TARGET=\"display\">$L{'Sessions'}</A>"  if (-e "$path$I$dirsep$dirsession$dirsep$filesession");

#print FOUT " | " if ((-e "$path$I$dirsep$dirsession$dirsep$filesession") && ((-e "$path$I$dirsep$dirlist$dirlist$filevirus") || (-e "$path$I$dirsep$dirlist$dirsep$filevirtual") || (-e "$path$I$dirsep$dirlist$dirsep$error") || (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")));
print FOUT " | " if ((-e "$path$I$dirsep$dirsession$dirsep$filesession") && (($nb_virus != 0) || (-e "$path$I$dirsep$dirlist$dirsep$filevirtual") || (-e "$path$I$dirsep$dirlist$dirsep$error") || (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")));

#print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filevirus\" TARGET=\"display\">$L{'Virus'}</A>"  if (-e "$path$I$dirsep$dirlist$dirsep$filevirus");
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filevirus\" TARGET=\"display\">$L{'Virus'}</A>"  if ($nb_virus != 0);

#print FOUT " | " if ((-e "$path$I$dirsep$dirlist$dirsep$filevirus") && ((-e "$path$I$dirsep$dirlist$dirsep$filevirtual") || (-e "$path$I$dirsep$dirlist$dirsep$error") || (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")));

print FOUT " | " if (($nb_virus != 0) && ((-e "$path$I$dirsep$dirlist$dirsep$filevirtual") || (-e "$path$I$dirsep$dirproxy$dirsep$filesquid") || (-e "$path$I$dirsep$dirlist$dirsep$error") || (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")));
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filevirtual\" TARGET=\"display\">$L{'Destination'}</A>"  if (-e "$path$I$dirsep$dirlist$dirsep$filevirtual");

print FOUT " | " if ((-e "$path$I$dirsep$dirlist$dirsep$filevirtual") && ((-e "$path$I$dirsep$dirproxy$dirsep$filesquid") || (-e "$path$I$dirsep$dirlist$dirsep$error") || (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")));
print FOUT "<A HREF=\"..$dirsepurl$dirproxy$dirsepurl$filesquid\" TARGET=\"display\">$L{'Proxy'}</A>"  if (-e "$path$I$dirsep$dirproxy$dirsep$filesquid");

print FOUT " | " if ((-e "$path$I$dirsep$dirproxy$dirsep$filesquid") && ((-e "$path$I$dirsep$dirlist$dirsep$error") || (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")));
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$error\" TARGET=\"display\">$L{'Errors'}</A>"  if (-e "$path$I$dirsep$dirlist$dirsep$error");

print FOUT " | " if ((-e "$path$I$dirsep$dirlist$dirsep$error") && ((-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")));
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$agent\" TARGET=\"display\">$L{'Browsers'}</A>"  if (-e "$path$I$dirsep$dirlist$dirsep$agent");

print FOUT " | " if ((-e "$path$I$dirsep$dirlist$dirsep$agent") && (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer"));
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$tabnamerefer\" TARGET=\"display\">$L{'Referer'}</A>"  if (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer");

print FOUT " | <A HREF=\"..$dirsepurl$dirlist$dirsepurl$tabnamekeyword\" TARGET=\"display\">$L{'Search_engine'}</A>"  if (-e "$path$I$dirsep$dirlist$dirsep$tabnamekeyword");
print FOUT "]";
}
} else {

print FOUT "<CENTER>\n";
print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$filesites\" TARGET=\"display\"><IMG WIDTH=34 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_hosts\" BORDER=0></A><BR>\n";
print FOUT "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$filesites\" TARGET=\"display\">$L{'Hosts'}</A><BR>";
print FOUT "<A HREF=\"..$dirsepurl$dirpage$dirsepurl$filepages\" TARGET=\"display\"><IMG WIDTH=34 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_pages\" BORDER=0></A><BR>\n";
print FOUT "<A HREF=\"..$dirsepurl$dirpage$dirsepurl$filepages\" TARGET=\"display\">$L{'Pages'}</A><BR>";
if ($inc_script == 1) {
    print FOUT "<A HREF=\"..$dirsepurl$dirscript$dirsepurl$filescript\" TARGET=\"display\"><IMG WIDTH=34 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_script\" BORDER=0></A><BR>\n";
    print FOUT "<A HREF=\"..$dirsepurl$dirscript$dirsepurl$filescript\" TARGET=\"display\">$L{'Scripts'}</A><BR>";
}

if ($precision > 2) {
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filetype$htmlext\" TARGET=\"display\"><IMG WIDTH=36 HEIGHT=28 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_filetype\" BORDER=0></A><BR>\n";
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filetype$htmlext\" TARGET=\"display\">$L{'Filetype'}</A><BR>";
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filerepert\" TARGET=\"display\"><IMG WIDTH=34 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_dir\" BORDER=0></A><BR>\n";
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filerepert\" TARGET=\"display\">$L{'Directories'}</A><BR>";
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$dirdownload$htmlext\" TARGET=\"display\"><IMG WIDTH=35 HEIGHT=30 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_pie\" BORDER=0></A><BR>\n";
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$dirdownload$htmlext\" TARGET=\"display\">$L{'Download'}</A><BR>\n";
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$dirtraffic$htmlext\" TARGET=\"display\"><IMG WIDTH=13 HEIGHT=35 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_traffic\" BORDER=0></A><BR>\n";
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$dirtraffic$htmlext\" TARGET=\"display\">$L{'Traffic'}</A>\n";
if ($paysunique != 0) {
print FOUT "<BR><A HREF=\"..$dirsepurl$dirpays$dirsepurl$filepays\" TARGET=\"display\"><IMG WIDTH=33 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_countries\" BORDER=0></A><BR>\n";
print FOUT "<A HREF=\"..$dirsepurl$dirpays$dirsepurl$filepays\" TARGET=\"display\">$L{'Countries'}</A>";
}
}

print FOUT "<P><HR><P>";
print FOUT "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$file_now\" TARGET=\"display\"><IMG WIDTH=26 HEIGHT=29 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_duree\" BORDER=0></A><BR>\n" if (-e "$path$I$dirsep$dirdate$dirsep$file_now");
print FOUT "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$file_now\" TARGET=\"display\">$L{'Real_time'}</A><BR>" if (-e "$path$I$dirsep$dirdate$dirsep$file_now");
print FOUT "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$filehour\" TARGET=\"display\"><IMG WIDTH=26 HEIGHT=29 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_hours\" BORDER=0></A><BR>\n" if (-e "$path$I$dirsep$dirdate$dirsep$filenamehour");
print FOUT "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$filehour\" TARGET=\"display\">$L{'Hours'}</A><BR>" if (-e "$path$I$dirsep$dirdate$dirsep$filenamehour");
print FOUT "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$fileday\" TARGET=\"display\"><IMG WIDTH=75 HEIGHT=42 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_days\" BORDER=0></A><BR>\n";
print FOUT "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$fileday\" TARGET=\"display\">$L{'Days'}</A>";
print FOUT "<BR><A HREF=\"..$dirsepurl$dirdate$dirsepurl$fileweek\" TARGET=\"display\"><IMG WIDTH=80 HEIGHT=50 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_weeks\" BORDER=0></A>" unless ($nbdays < 14);
print FOUT "<BR><A HREF=\"..$dirsepurl$dirdate$dirsepurl$fileweek\" TARGET=\"display\">$L{'Weeks'}</A>" unless ($nbdays < 14);
print FOUT "<BR><A HREF=\"..$dirsepurl$dirdate$dirsepurl$filemonth\" TARGET=\"display\"><IMG WIDTH=33 HEIGHT=33 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_months\" BORDER=0></A>" if ($nbdays > 30 || $count_month > 0);
print FOUT "<BR><A HREF=\"..$dirsepurl$dirdate$dirsepurl$filemonth\" TARGET=\"display\">$L{'Months'}</A>" if ($nbdays > 30 || $count_month > 0);
print FOUT "<P><HR><P>\n";

if ((-e "$path$I$dirsep$dirlist$dirsep$error") || (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")) {
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$error\" TARGET=\"display\"><IMG WIDTH=42 HEIGHT=40 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_error\" BORDER=0></A><BR>\n" if (-e "$path$I$dirsep$dirlist$dirsep$error");
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$error\" TARGET=\"display\">$L{'Errors'}</A>" if (-e "$path$I$dirsep$dirlist$dirsep$error");
print FOUT "<BR>" if ((-e "$path$I$dirsep$dirlist$dirsep$error") && ((-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")));
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$agent\" TARGET=\"display\"><IMG WIDTH=37 HEIGHT=39 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_agent\" BORDER=0></A><BR>\n" if (-e "$path$I$dirsep$dirlist$dirsep$agent");
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$agent\" TARGET=\"display\">$L{'Browsers'}</A>" if (-e "$path$I$dirsep$dirlist$dirsep$agent");
print FOUT "<BR>" if ((-e "$path$I$dirsep$dirlist$dirsep$agent") && (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer"));
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$tabnamerefer\" TARGET=\"display\"><IMG WIDTH=34 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_refer\" BORDER=0></A><BR>\n" if (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer");
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$tabnamerefer\" TARGET=\"display\">$L{'Referer'}</A>" if (-e "$path$I$dirsep$dirlist$dirsep$tabnamerefer");
print FOUT "<P><HR><P>\n";
}

if ((-e "$path$I$dirsep$dirdocument$dirsep$menu") || (-e "$path$I$dirsep$dirsession$dirsep$filesession") || ($nb_virus != 0)) {
print FOUT "<A HREF=\"..$dirsepurl$dirdocument$dirsepurl$menu\" TARGET=\"display\"><IMG WIDTH=53 HEIGHT=33 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_doc\" BORDER=0></A><BR>\n" if (-e "$path$I$dirsep$dirdocument$dirsep$menu");
print FOUT "<A HREF=\"..$dirsepurl$dirdocument$dirsepurl$menu\" TARGET=\"display\">$L{'Documents'}</A>" if (-e "$path$I$dirsep$dirdocument$dirsep$menu");

print FOUT "<BR>" if ((-e "$path$I$dirsep$dirdocument$dirsep$menu") && ((-e "$path$I$dirsep$dirsession$dirsep$filesession") || ($nb_virus != 0)));
print FOUT "<A HREF=\"..$dirsepurl$dirsession$dirsepurl$filesession\" TARGET=\"display\"><IMG WIDTH=38 HEIGHT=39 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_session\" BORDER=0></A><BR>\n" if (-e "$path$I$dirsep$dirsession$dirsep$filesession");
print FOUT "<A HREF=\"..$dirsepurl$dirsession$dirsepurl$filesession\" TARGET=\"display\">$L{'Sessions'}</A>" if (-e "$path$I$dirsep$dirsession$dirsep$filesession");

print FOUT "<BR>" if ((-e "$path$I$dirsep$dirsession$dirsep$filesession") && (($nb_virus != 0) || (-e "$path$I$dirsep$dirlist$dirsep$filevirtual") || (-e "$path$I$dirsep$dirproxy$dirsep$filesquid")));
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filevirus\" TARGET=\"display\"><IMG WIDTH=28 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_virus\" BORDER=0></A><BR>\n" if ($nb_virus != 0);
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filevirus\" TARGET=\"display\">$L{'Virus'}</A>" if ($nb_virus != 0);

print FOUT "<BR>\n" if (($nb_virus != 0) && ((-e "$path$I$dirsep$dirlist$dirsep$filevirtual") || (-e "$path$I$dirsep$dirproxy$dirsep$filesquid")));
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filevirtual\" TARGET=\"display\"><IMG WIDTH=34 HEIGHT=33 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_virtual\" BORDER=0></A>\n";
print FOUT "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filevirtual\" TARGET=\"display\">$L{'Destination'}</A>"  if (-e "$path$I$dirsep$dirlist$dirsep$filevirtual");

print FOUT "<BR>" if ((-e "$path$I$dirsep$dirlist$dirsep$filevirtual") && ((-e "$path$I$dirsep$dirproxy$dirsep$filesquid")));
print FOUT "<A HREF=\"..$dirsepurl$dirproxy$dirsepurl$filesquid\" TARGET=\"display\"><IMG WIDTH=35 HEIGHT=35 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_squid\" BORDER=0></A>\n";
print FOUT "<A HREF=\"..$dirsepurl$dirproxy$dirsepurl$filesquid\" TARGET=\"display\">$L{'Proxy'}</A>"  if (-e "$path$I$dirsep$dirproxy$dirsep$filesquid");

print FOUT "</CENTER>\n";
}

}
print FOUT "</CENTER>";

print FOUT "</BODY></HTML>";
}

#################################################################
####                   Homepage                           #######
#################################################################

sub CreateLittleIndex {
  local(*FOUT,*L, $H, $I, $J) = @_;

print FOUT "<HTML><HEAD>\n";
print FOUT "<TITLE>$L{'Stats_about_host'} $localserver </TITLE>\n";
print FOUT "<!-- Page generated by w3perl - cron-pages.pl $version - $today $hourdate -->\n";
print FOUT "<META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">";
print FOUT "</HEAD>\n";

print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
print FOUT "<H1> <IMG WIDTH=49 HEIGHT=49 SRC=\"$linkpathinit$dirress$dirsepurl$drawstat\"> $L{'Stats'} $firstday - $yesterday</H1><P>\n";

print FOUT "<HR>";
for ($i=0;$i<=$#lang;$i++) {
print FOUT "&nbsp;<A HREF=\"$homepages[$i]\"><IMG border=0 WIDTH=30 HEIGHT=15 SRC=\"$linkpathinit$dirress$dirsepurl$flag[$i]\" ALT=\"$flag[$i]\"></A>&nbsp;\n" unless ($I eq $lang[$i]);
}

print FOUT "<HR><P>\n" if ($#lang > 0);

print FOUT "<CENTER>\n";
print FOUT "[<A HREF=\"http://$localserver$tri\">Homepage</A>] | [";
print FOUT "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$menu\">$L{'Documents'}</A> | "  if (-e "$path$I$dirsep$dirlist$dirsep$menu");
print FOUT "<A HREF=\"$I$dirsepurl$dirsession$dirsepurl$filesession\">$L{'Sessions'}</A> | "  if (-e "$path$I$dirsep$dirsession$dirsep$filesession");
print FOUT "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$error\">$L{'Errors'}</A> | "  if (-e "$path$I$dirsep$dirlist$dirsep$error");
print FOUT "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$refer\">$L{'Referer'}</A> | "  if (-e "$path$I$dirsep$dirlist$dirsep$refer");
print FOUT "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$agent\">$L{'Browsers'}</A> | "  if (-e "$path$I$dirsep$dirlist$dirsep$agent");
print FOUT "<A HREF=\"http://www.w3perl.com/demo/docs/html/new.html?$version\">$L{'News'}</A> | ";
print FOUT "<A HREF=\"$linkpathinit$dirdocs$dirsepurl$help\">$L{'Docs'}</A>\n";
print FOUT "]</CENTER>";

print FOUT "<HR><P>\n";

print FOUT "$L{'Total_number_of_requests'} ($L{'all_sites'}) : $reqtot\n<BR>";
print FOUT "$L{'Total_number_of_requests'} $L{'from_dom'} <I>$localdomainename</I> : $reqdomtot\n<BR>" if ($locallog != 0 && $locserver != 0);
print FOUT "<P>";
print FOUT "$L{'Number_of_different_sites'} : $serveruniquetot\n<BR>";
print FOUT "$L{'Number_of_pages_read'} : $access\n<br>";
print FOUT "$L{'Number_of_different_pages_used'} : $pageunique\n\n<BR>";
print FOUT "$L{'Total_data_sent'} : ";
printf FOUT "%.2f",$totsize;
print FOUT " $L{'Mb'}\n";
if ($locallog != 0 && $locserver != 0) {
print FOUT "($L{'among'} ";
printf FOUT "%.2f",$externesize;
print FOUT " $L{'from_outside'})";
}
print FOUT "\n<BR>";

print FOUT "<P><HR><P>";

print FOUT "<I>$L{'The_Top'} $topten $L{'top_external_sites'} ($L{'among'} $serverunique)</I> :<P><UL>\n";
for ($i=0;$i < $boucleservers;$i++) {
print FOUT "$bestserver[$i] : <b>$occurserver[$i]</b> $L{'times'}<br>";
}

print FOUT "</UL>";

if ($locallog != 0 && $locserver != 0) {
print FOUT "<I>$L{'The_Top'} $topten $L{'top_local_sites'} ($L{'among'} $locserver)</I> :<P><UL>\n";
for ($i=0;$i < $bouclelocservers;$i++) {
print FOUT "$bestlocserver[$i] : <b>$occurlocserver[$i]</b><br>";
}
}

print FOUT "</UL><I>$L{'The_Top'} $topten $L{'pages'} ($L{'among'} $pageunique) $L{'MostSuccesf'}</I> :<P><UL>\n";
for ($i=0;$i < $bouclepages;$i++) {
print FOUT "<A HREF=\"$linkpage$bestpage[$i]\">";
print FOUT "$bestpage[$i]" if ($titlename == 0);
print FOUT "<b>$urlconv{$bestpage[$i]}</b>" if ($titlename == 1 && $urlconv{$bestpage[$i]} ne '');
print FOUT "$bestpage[$i]" if ($titlename == 1 && $urlconv{$bestpage[$i]} eq '');
print FOUT "</A> : <B>$occur[$i]</B> $L{'times'}<BR>\n";
}
print FOUT "</UL>";

print FOUT "<HR><BR>\n";

print FOUT "<TABLE BORDER=0 WIDTH=100\%><TR>\n";
print FOUT "<TD ALIGN=LEFT>";
#print FOUT "<I><FONT SIZE=2>&#169; Copyright 1995/2003 <A HREF=\"mailto:domisse\@w3perl.com\">Laurent DOMISSE</A></FONT></I>";
print FOUT "</TD>\n";
print FOUT "<TD ALIGN=RIGHT><I><FONT SIZE=2>$L{'Stats'} $L{'computed_with'} <A HREF=\"$linkpathinit$dirdocs$dirsepurl$help\">W3Perl $version</A> </FONT></I>\n";
print FOUT "</TR></TABLE>\n";
print FOUT "</BODY>\n";
print FOUT "</HTML>\n";
}

#################################################################
####                   Homepage                           #######
#################################################################

sub CreateMainIndex {
  local(*FOUT1,*FOUT2,*L, $H, $I, $J) = @_;
  local($tmp);

  print FOUT1 "<HTML>\n";
  print FOUT1 "<HEAD>\n";
  print FOUT1 "<LINK rel=\"icon\" type=\"image/png\" href=\"$linkpathinit$dirress$dirsepurl$favicon$pngext\" />\n";
  print FOUT1 "<LINK rel=\"shortcut icon\" type=\"image/x-icon\" href=\"$linkpathinit$dirress$dirsepurl$favicon$icoext\" />\n";

print FOUT1 "<TITLE>$L{'Stats_about_host'} $localserver - Frames</TITLE>\n";
print FOUT1 "<!-- Page generated by w3perl - cron-pages.pl $version - $today $hourdate -->\n";
print FOUT1 "<META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">";
&popup_help(*FOUT1);
print FOUT1 "</HEAD>\n";

print FOUT1 "<FRAMESET ROWS=\"8\%,*,10\%\" FRAMEBORDER=\"no\" FRAMESPACING=0 BORDER=0>" if ($frame_updown == 1);
print FOUT1 "<FRAMESET COLS=\"8\%,*,11\%\" FRAMEBORDER=\"no\"  FRAMESPACING=0 BORDER=0>" if ($frame_updown == 0);
print FOUT1 "<FRAME SCROLLING=\"auto\"  NAME=\"top\" SRC=\"$I$dirsepurl$dirframe$dirsepurl$topframe\">\n";
print FOUT1 "<FRAME SCROLLING=\"auto\" NAME=\"display\" SRC=\"$I$dirsepurl$dirframe$dirsepurl$J\">\n";
print FOUT1 "<FRAME SCROLLING=\"auto\"  NAME=\"bottom\" SRC=\"$I$dirsepurl$dirframe$dirsepurl$bottomframe\">\n";
print FOUT1 "</FRAMESET>\n";

print FOUT1 "<NOFRAMES>\n";

print FOUT1 "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
print FOUT1 "<H1> <IMG WIDTH=49 HEIGHT=49 SRC=\"$linkpathinit$dirress$dirsepurl$drawstat\"> $L{'Stats'} $firstday - $yesterday</H1><P>\n";
print FOUT1 "<HR>\n";

for ($i=0;$i<=$#lang;$i++) {
print FOUT1 "<A HREF=\"$homepages[$i]\" TARGET=\"_top\"><IMG border=0 WIDTH=30 HEIGHT=15 SRC=\"$linkpathinit$dirress$dirsepurl$flag[$i]\" ALT=\"$flag[$i]\"> $lang[$i]</A> \n" unless ($I eq $lang[$i]);
}

print FOUT1 "<HR><P>\n" if ($#lang > 0);

print FOUT1 "<CENTER>\n";
print FOUT1 "[<A HREF=\"http://$localserver$tri\">Homepage</A>] | [";
print FOUT1 "<A HREF=\"http://www.w3perl.com/demo/docs/html/new.html?$version\">$L{'News'}</A> | ";
print FOUT1 "<A HREF=\"$linkpathinit$dirdocs$dirsepurl$help\">$L{'Docs'}</A>\n";
print FOUT1 "]</CENTER>";

print FOUT1 "<HR><P>\n";

### Big tableau

print FOUT1 "<CENTER>\n";
print FOUT1 "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=8 WIDTH=100%><TR><TD VALIGN=TOP>\n";

### 1er tableau

print FOUT1 "<TABLE BORDER=0 CELLPADDING=1 BGCOLOR=\"#DDDDDD\" CELLSPACING=3>\n<TR>\n";
  $tmp_help = "global.html";
  if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help") {
      print FOUT1 "<TH ALIGN=LEFT BGCOLOR=\"#DDDDDD\"><A HREF=\"javascript:HelpDisplay('$tmp_help')\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$icon_help\" BORDER=0></A></TH>";
  }
print FOUT1 "<TH><FONT SIZE=+1>$L{'Global_access'}</FONT></TH>\n<TD ALIGN=CENTER><I>$L{'Total'}</I></TD>\n";
print FOUT1 "<TD ALIGN=CENTER><I>$L{'external'}</I></TD>\n<TD ALIGN=CENTER><I>$L{'local'}</I></TD>" if ($locallog == 1 && $localonly != 1);
print FOUT1 "</TR>\n<TR>\n";
print FOUT1 "<TD ";
print FOUT1 "COLSPAN=2 " if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
print FOUT1 "ALIGN=LEFT>$L{'Requests'}</TD>\n";
print FOUT1 "<TD ALIGN=CENTER BGCOLOR=\"#00FFFF\">$reqtot</TD>\n";
if ($locallog == 1 && $localonly != 1) {
print FOUT1 "<TD ALIGN=CENTER>".($reqtot - $reqdomtot)."</TD>\n";
print FOUT1 "<TD ALIGN=CENTER>$reqdomtot</TD>\n";
}
print FOUT1 "</TR>\n<TR>\n";
  if ($ftp_format == 0) {
      print FOUT1 "<TD ";
      print FOUT1 "COLSPAN=2 " if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      print FOUT1 "ALIGN=LEFT>$L{'Accesses'}</TD>\n";
      print FOUT1 "<TD ALIGN=CENTER BGCOLOR=\"#00FF00\">$access</TD>\n";
      if ($locallog == 1 && $localonly != 1) {
	  print FOUT1 "<TD ALIGN=CENTER>".($access - $accessdom)."</TD>\n";
	  print FOUT1 "<TD ALIGN=CENTER>$accessdom</TD>\n";
      }
  }
  if ($ftp_format == 1) {
      $tmp = $totsize_in;
      $tmp = $totsize_in/1024 if ($totsize_in >= 1024);
      $tmp = $totsize_in/(1024*1024) if ($totsize_in >= (1024*1024));
      print FOUT1 "<TD ";
      print FOUT1 "COLSPAN=2 " if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      print FOUT1 ">$L{'Incoming_traffic'} ";
      print FOUT1 "($L{'Mb'})" if ($totsize_in < 1024);
      print FOUT1 "($L{'Gb'})" if ($totsize_in > 1024 && $totsize_in < (1024*1024));
      print FOUT1 "($L{'Tb'})" if ($totsize_in > (1024*1024));
      print FOUT1 "</TD>\n";
      print FOUT1 "<TD ALIGN=CENTER BGCOLOR=\"#00FF00\">";
      printf FOUT1 "%.2f",$tmp;
      print FOUT1 "</TD>\n";
      if ($locallog == 1 && $localonly != 1) {
	  print FOUT1 "<TD ALIGN=CENTER>-</TD>\n";
	  print FOUT1 "<TD ALIGN=CENTER>-</TD>\n";
      }
  }
print FOUT1 "</TR>\n<TR>\n";
print FOUT1 "<TD>$L{'Traffic'} ";
  $tmp = $totsize;
  $tmp = $totsize/1024 if ($totsize >= 1024);
  $tmp = $totsize/(1024*1024) if ($totsize >= (1024*1024));
  print FOUT1 "<TD ";
  print FOUT1 "COLSPAN=2 " if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
  print FOUT1 "ALIGN=LEFT>$L{'Outgoing_traffic'} " if ($ftp_format == 1);
  print FOUT1 "ALIGN=LEFT>$L{'Traffic'} " if ($ftp_format == 0);
print FOUT1 "($L{'Mb'})" if ($totsize < 1024);
print FOUT1 "($L{'Gb'})" if ($totsize > 1024 && $totsize < (1024*1024));
print FOUT1 "($L{'Tb'})" if ($totsize > (1024*1024));
print FOUT1 "</TD>\n";
print FOUT1 "<TD ALIGN=CENTER BGCOLOR=\"#CCCCCC\">";
printf FOUT1 "%.2f",$tmp;
print FOUT1 "</TD>\n";
if ($locallog == 1 && $localonly != 1) {
  $tmp = $externesize;
  $tmp = $externesize/1024 if ($totsize >= 1024);
  $tmp = $externesize/(1024*1024) if ($totsize > (1024*1024));
print FOUT1 "<TD ALIGN=CENTER>";
printf FOUT1 "%.2f",$tmp;
print FOUT1 "</TD>\n";
  $tmp = $domsize;
  $tmp = $domsize/1024 if ($totsize >= 1024);
  $tmp = $domsize/(1024*1024) if ($totsize > (1024*1024));
print FOUT1 "<TD ALIGN=CENTER>";
printf FOUT1 "%.2f",$tmp;
print FOUT1 "</TD>\n";
}
print FOUT1 "</TR>\n</TABLE>\n";

#
print FOUT1 "</TD><TD VALIGN=TOP ROWSPAN=2>";

### 4ieme tableau

  if ($nbdays != 0) {
print FOUT1 "<TABLE BORDER=0 CELLPADDING=1 BGCOLOR=\"#DDDDDD\" CELLSPACING=3>\n<TR>\n";
print FOUT1 "<TH ALIGN=LEFT><FONT SIZE=+1>$L{'Average'}</FONT></TH>\n";
print FOUT1 "<TD ALIGN=LEFT>$L{'Days'}</TD>\n";
print FOUT1 "</TR>\n<TR>\n";
print FOUT1 "<TD ALIGN=LEFT>$L{'Requests'}</TD>\n";
print FOUT1 "<TD ALIGN=RIGHT>".int($reqtot/$nbdays)."</TD>\n";
print FOUT1 "</TR>\n<TR>\n";
print FOUT1 "<TD ALIGN=LEFT>$L{'Accesses'}</TD>\n";
print FOUT1 "<TD ALIGN=RIGHT>".int($access/$nbdays)."</TD>\n";
print FOUT1 "</TR>\n<TR>\n";
print FOUT1 "<TD ALIGN=LEFT>$L{'Hosts'}</TD>\n";
print FOUT1 "<TD ALIGN=RIGHT>".int($serveruniquetot/$nbdays)."</TD>\n";
print FOUT1 "</TR>\n<TR>\n";
print FOUT1 "<TD ALIGN=LEFT>$L{'Traffic'} ";
$tmp1 = $totsize/$nbdays;
$tmp = $tmp1;
$tmp = $tmp1/1024 if ($tmp1 > 1024);
$tmp = $tmp1/(1024*1024) if ($tmp1 > (1024*1024));
print FOUT1 "($L{'Mb'})" if ($tmp1 < 1024);
print FOUT1 "($L{'Gb'})" if ($tmp1 > 1024 && $tmp1 < (1024*1024));
print FOUT1 "($L{'Tb'})" if ($tmp1 > (1024*1024));
print FOUT1 "</TD>\n";
printf FOUT1 "<TD ALIGN=RIGHT>%.1f</TD>\n",$tmp;
print FOUT1 "</TR>\n</TABLE>\n";
}

print FOUT1 "</TD><TD VALIGN=TOP ROWSPAN=2>";

### 3ieme tableau

print FOUT1 "<TABLE BORDER=0 CELLPADDING=1 BGCOLOR=\"#DDDDDD\" CELLSPACING=3><TR>\n";
print FOUT1 "<TH ALIGN=LEFT COLSPAN=4><FONT SIZE=+1>$L{'Acces_not_taken_into_account'}</FONT></TH>\n";
print FOUT1 "</TR>\n<TR>\n";
print FOUT1 "<TD COLSPAN=3 ALIGN=LEFT>$L{'Total'}</TD><TD ALIGN=RIGHT BGCOLOR=\"#00FFFF\">".($loglines - $reqtot)."</TD>\n";
print FOUT1 "</TR>\n<TR>\n";
print FOUT1 "</TD><TD>$L{'Proxy'} (304)</TD><TD ALIGN=RIGHT>$proxy</TD>\n";
print FOUT1 "<TD>$L{'Pages_excluding'}</TD><TD ALIGN=RIGHT>$exclpages</TD>\n";
print FOUT1 "</TR>\n<TR>\n";
print FOUT1 "<TD>$L{'Redirect'} (302)</TD><TD ALIGN=RIGHT>$redirect</TD>\n";
print FOUT1 "<TD>$L{'Hosts_excluding'}</TD><TD ALIGN=RIGHT>$excladdr</TD>\n";
print FOUT1 "</TR>\n<TR>\n";
print FOUT1 "</TD><TD>$L{'Forbidden'} (403)</TD><TD ALIGN=RIGHT>$forbiden</TD>\n";
print FOUT1 "<TD>$L{'Frames_excluding'}</TD><TD ALIGN=RIGHT>$exclframed</TD>\n";
print FOUT1 "</TR>\n<TR>\n";
print FOUT1 "<TD>";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsep$incstatus$htmlext\">" if (-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$incstatus$htmlext");
print FOUT1 "$L{'Not_found'}";
print FOUT1 "</A>" if (-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$incstatus$htmlext");
print FOUT1 " (404)</TD><TD ALIGN=RIGHT>$notfound</TD>\n";
print FOUT1 "<TD>$L{'Robots_excluding'}</TD><TD ALIGN=RIGHT>$exclrobots</TD>\n";
#print FOUT1 "</TR><TR>\n";
#print FOUT1 "</TR><TR>\n";
print FOUT1 "</TR>\n</TABLE>\n";

#

print FOUT1 "</TD></TR><TR><TD VALIGN=BOTTOM>";

### 2ieme tableau

print FOUT1 "<TABLE BORDER=0 CELLPADDING=0 BGCOLOR=\"#DDDDDD\" CELLSPACING=3>\n";
print FOUT1 "<TR>\n";
print FOUT1 "<TD>$L{'Number_of_different_pages_used'}</TD>";
print FOUT1 "<TD ALIGN=RIGHT>&nbsp;$pageunique&nbsp;</TD>\n";
print FOUT1 "</TR>\n<TR>\n";
print FOUT1 "<TD>$L{'Number_of_different_sites'}</TD>";
print FOUT1 "<TD ALIGN=RIGHT>&nbsp;$serveruniquetot&nbsp;</TD>\n";
print FOUT1 "</TR>\n";
if ($precision > 2 && $paysunique != 0) {
print FOUT1 "<TR><TD>$L{'Number_of_different_resolved_countries'}</TD>";
print FOUT1 "<TD ALIGN=RIGHT>&nbsp;$paysunique&nbsp;</TD></TR>\n";
}
print FOUT1 "</TABLE>\n";

#

print FOUT1 "</TD></TR></TABLE>\n";
print FOUT1 "</CENTER>\n";

print FOUT1 "<P><HR><P>\n";

print FOUT1 "<CENTER>\n";
print FOUT1 "<TABLE WIDTH=100% CELLPADDING=5 CELLSPACING=5 BORDER=1>\n";
print FOUT1 "<TR>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=CENTER>\n";

### pointeurs sur les sites, pages et pays

print FOUT1 "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>\n";
print FOUT1 "<TR>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirsite$dirsepurl$filesites\"><IMG WIDTH=34 HEIGHT=34 SRC=\"$homeicons$dirsepurl$icon_hosts\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirsite$dirsepurl$filesites\">$L{'Hosts'}</A>\n";
print FOUT1 "</FONT></TD>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirpage$dirsepurl$filepages\"><IMG WIDTH=34 HEIGHT=34 SRC=\"$homeicons$dirsepurl$icon_pages\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirpage$dirsepurl$filepages\">$L{'Pages'}</A>\n";
print FOUT1 "</FONT></TD>\n";
if ($precision > 2) {
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filetype$htmlext\"><IMG WIDTH=36 HEIGHT=28 SRC=\"$homeicons$dirsepurl$icon_filetype\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filetype$htmlext\">$L{'Filetype'}</A>\n";
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
}
if ($inc_script == 1) {
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirscript$dirsepurl$filescript\"><IMG WIDTH=34 HEIGHT=34 SRC=\"$homeicons$dirsepurl$icon_script\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirscript$dirsepurl$filescript\">$L{'Scripts'}</A>\n";
print FOUT1 "</FONT></TD>\n";
}
print FOUT1 "</TR>\n";
if ($precision > 2) {
print FOUT1 "<TR>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filerepert\"><IMG WIDTH=34 HEIGHT=34 SRC=\"$homeicons$dirsepurl$icon_dir\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filerepert\">$L{'Directories'}</A>\n";
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
if ($paysunique != 0) {
print FOUT1 "<A HREF=\"$I$dirsepurl$dirpays$dirsepurl$filepays\"><IMG WIDTH=30 HEIGHT=30 SRC=\"$homeicons$dirsepurl$icon_countries\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirpays$dirsepurl$filepays\">$L{'Countries'}</A>\n";
print FOUT1 "</FONT>\n";
}
print FOUT1 "</TD>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$dirdownload$htmlext\"><IMG WIDTH=35 HEIGHT=30 SRC=\"$homeicons$dirsepurl$icon_pie\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$dirdownload$htmlext\">$L{'Download'}</A>\n";
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$dirtraffic$htmlext\"><IMG WIDTH=13 HEIGHT=35 SRC=\"$homeicons$dirsepurl$icon_traffic\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirlist$dirsepurl$dirtraffic$htmlext\">$L{'Traffic'}</A>\n";
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
print FOUT1 "</TR>\n";
}

print FOUT1 "</TABLE>\n";

###

print FOUT1 "</TD>\n";
print FOUT1 "<TD ROWSPAN=3 ALIGN=CENTER VALIGN=CENTER>\n";

### pointeurs sur les heures,jours, semaines et mois

print FOUT1 "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>\n";
print FOUT1 "<TR>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$file_now\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$file_now");
print FOUT1 "<IMG WIDTH=34 HEIGHT=34 SRC=\"$homeicons$dirsepurl$icon_duree\" BORDER=0>";
print FOUT1 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$file_now");
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$file_now\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$file_now");
print FOUT1 "$L{'Real_time'}";
print FOUT1 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$file_now");
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
print FOUT1 "</TR><TR>\n";
print FOUT1 "<TR>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$filehour\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
print FOUT1 "<IMG WIDTH=26 HEIGHT=29 SRC=\"$homeicons$dirsepurl$icon_hours\" BORDER=0>";
print FOUT1 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$filehour\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
print FOUT1 "$L{'Hours'}";
print FOUT1 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
print FOUT1 "</TR><TR>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$fileday\"><IMG WIDTH=75 HEIGHT=42 SRC=\"$homeicons$dirsepurl$icon_days\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$fileday\">$L{'Days'}</A>\n";
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
print FOUT1 "</TR><TR>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$fileweek\">" unless ($nbdays < 14);
print FOUT1 "<IMG WIDTH=80 HEIGHT=50 SRC=\"$homeicons$dirsepurl$icon_weeks\" BORDER=0>";
print FOUT1 "</A>\n" unless ($nbdays < 14);
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$fileweek\">" unless ($nbdays < 14);
print FOUT1 "$L{'Weeks'}";
print FOUT1 "</A>" unless ($nbdays < 14);
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
print FOUT1 "</TR><TR>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$filemonth\">" if ($nbdays > 30 || $count_month > 0);
print FOUT1 "<IMG WIDTH=33 HEIGHT=33 SRC=\"$homeicons$dirsepurl$icon_months\" BORDER=0>";
print FOUT1 "</A>\n" if ($nbdays > 30 || $count_month > 0);
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirdate$dirsepurl$filemonth\">" if ($nbdays > 30 || $count_month > 0);
print FOUT1 "$L{'Months'}";
print FOUT1 "</A>" if ($nbdays > 30 || $count_month > 0);
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
print FOUT1 "</TR>\n";
print FOUT1 "</TABLE>\n";

###

print FOUT1 "</TD>\n";
print FOUT1 "</TR>\n";
print FOUT1 "<TR>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=CENTER>\n";

### pointeurs sur les erreurs, references et fureteurs

if ((-e "$path$I$dirsep$dirlist$dirsep$error") || (-e "$path$I$dirsep$dirlist$dirsep$refer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")) {
print FOUT1 "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>\n";
print FOUT1 "<TR>\n";
if (-e "$path$I$dirsep$dirlist$dirsep$error") {
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$error\"><IMG WIDTH=42 HEIGHT=40 SRC=\"$homeicons$dirsepurl$icon_error\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$error\">$L{'Errors'}</A>\n";
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
}
if (-e "$path$I$dirsep$dirlist$dirsep$agent") {
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$agent\"><IMG WIDTH=37 HEIGHT=39 SRC=\"$homeicons$dirsepurl$icon_agent\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$agent\">$L{'Browsers'}</A>\n";
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
}
if (-e "$path$I$dirsep$dirlist$dirsep$refer") {
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$refer\"><IMG WIDTH=34 HEIGHT=34 SRC=\"$homeicons$dirsepurl$icon_refer\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$refer\">$L{'Referer'}</A>\n";
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
}
print FOUT1 "</TR>\n";
print FOUT1 "</TABLE>\n";
}

###

print FOUT1 "</TD>\n";
print FOUT1 "</TR>\n";
print FOUT1 "<TR>\n";
print FOUT1 "<TD ALIGN=CENTER VALIGN=CENTER>\n";

### pointeurs sur les sessions et documents, virus

#if ((-e "$path$I$dirsep$dirdocument$dirsep$menu") || (-e "$path$I$dirsep$dirsession$dirsep$filesession") || (-e "$path$I$dirsep$dirlist$dirsep$filevirus") || ($virtualfilter eq '' && $virtualunique != 0)) {
if ((-e "$path$I$dirsep$dirdocument$dirsep$menu") || (-e "$path$I$dirsep$dirsession$dirsep$filesession") || ($nb_virus != 0) || ($virtualfilter eq '' && $virtualunique != 0)) {
print FOUT1 "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>\n";
print FOUT1 "<TR>\n";
if (-e "$path$I$dirsep$dirdocument$dirsep$menu") {
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirdocument$dirsepurl$menu\"><IMG WIDTH=53 HEIGHT=33 SRC=\"$homeicons$dirsepurl$icon_doc\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirdocument$dirsepurl$menu\">$L{'Documents'}</A>\n";
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
}
if (-e "$path$I$dirsep$dirsession$dirsep$filesession") {
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirsession$dirsepurl$filesession\"><IMG WIDTH=38 HEIGHT=39 SRC=\"$homeicons$dirsepurl$icon_session\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirsession$dirsepurl$filesession\">$L{'Sessions'}</A>\n";
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
}
#if (-e "$path$I$dirsep$dirlist$dirsep$filevirus") {
if ($nb_virus != 0) {
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filevirus\"><IMG WIDTH=28 HEIGHT=34 SRC=\"$homeicons$dirsepurl$icon_virus\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filevirus\">$L{'Virus'}</A>\n";
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
}
if ($virtualfilter eq '' && $virtualunique != 0) {
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filevirtual\"><IMG WIDTH=34 HEIGHT=33 SRC=\"$homeicons$dirsepurl$icon_virtual\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filevirtual\">$L{'Destination'}</A>\n";
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
}
if ($squid_format == 1) {
print FOUT1 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT1 "<A HREF=\"..$dirsepurl$dirproxy$dirsepurl$filesquid\"><IMG WIDTH=35 HEIGHT=35 SRC=\"$homeicons$dirsepurl$icon_squid\" BORDER=0></A>\n";
print FOUT1 "<BR><FONT SIZE=+1>\n";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirproxy$dirsepurl$filesquid\">$L{'Proxy'}</A>\n";
print FOUT1 "</FONT>\n";
print FOUT1 "</TD>\n";
}
print FOUT1 "</TR>\n";
print FOUT1 "</TABLE>\n";
}

##

print FOUT1 "</TD>\n";
print FOUT1 "</TR>\n";
print FOUT1 "</TABLE>\n";

print FOUT1 "</CENTER>\n";

print FOUT1 "<BR>\n";

print FOUT1 "<TABLE BORDER=0 WIDTH=100\%><TR>\n";
print FOUT1 "<TD ALIGN=LEFT>";
#print FOUT1 "<I><FONT SIZE=2>&#169; Copyright 1995/2003 <A HREF=\"mailto:domisse\@w3perl.com\">Laurent DOMISSE</A></FONT></I>";
print FOUT1 "</TD>\n";
print FOUT1 "<TD ALIGN=RIGHT><I><FONT SIZE=2>";
print FOUT1 "<A HREF=\"$I$dirsepurl$dirlist$dirsepurl$filecpu\">" if (-e "$path$I$dirsep$dirlist$dirsep$filecpu");
print FOUT1 "$L{'Stats'}";
print FOUT1 "</A>" if (-e "$path$I$dirsep$dirlist$dirsep$filecpu");
print FOUT1 " $L{'computed_with'} <A HREF=\"$linkpathinit$dirdocs$dirsepurl$help\">W3Perl $version</A> </FONT></I></TD>\n";
print FOUT1 "</TR></TABLE>\n";
print FOUT1 "</BODY>\n";

print FOUT1 "</NOFRAMES>\n";
print FOUT1 "</HTML>\n";

### version pour le frame

print FOUT2 "<HTML><HEAD>\n";
print FOUT2 "<TITLE>$L{'Stats_about_host'} $localserver - Frame Menu</TITLE>\n";
print FOUT2 "<!-- Page generated by w3perl - cron-pages.pl $version - $today $hourdate -->\n";
print FOUT2 "<META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">";
&popup_help(*FOUT2);
print FOUT2 "</HEAD>\n";

print FOUT2 "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
print FOUT2 "<H1> <IMG WIDTH=49 HEIGHT=49 SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$drawstat\"> $L{'Stats'} $firstday - $yesterday</H1><P>\n";
print FOUT2 "<HR>\n";

for ($i=0;$i<=$#lang;$i++) {
print FOUT2 "&nbsp;<A HREF=\"..$dirsepurl..$dirsepurl$homepages[$i]\" TARGET=\"_top\"><IMG BORDER=0 WIDTH=30 HEIGHT=15 SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$flag[$i]\"></A>&nbsp;\n" unless ($I eq $lang[$i]);
}

print FOUT2 "<HR><P>\n" if ($#lang > 0);

### Big tableau

print FOUT2 "<CENTER>\n";
print FOUT2 "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=8 WIDTH=100%>\n<TR>\n<TD VALIGN=TOP>\n";

### 1er tableau

print FOUT2 "<TABLE BORDER=0 CELLPADDING=1 BGCOLOR=\"#DDDDDD\" CELLSPACING=3>\n<TR>\n";
  $tmp_help = "global.html";
  if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help") {
      print FOUT2 "<TH ALIGN=LEFT BGCOLOR=\"#DDDDDD\"><A HREF=\"javascript:HelpDisplay('$tmp_help')\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$icon_help\" BORDER=0></A></TH>";
  }
print FOUT2 "<TH><FONT SIZE=+1>$L{'Global_access'}</FONT></TH>\n<TD ALIGN=CENTER><I>$L{'Total'}</I></TD>\n";
print FOUT2 "<TD ALIGN=CENTER><I>$L{'external'}</I></TD><TD ALIGN=CENTER><I>$L{'local'}</I></TD>" if ($locallog == 1 && $localonly != 1);
print FOUT2 "</TR>\n<TR>\n";
print FOUT2 "<TD ";
  print FOUT2 "COLSPAN=2 " if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
print FOUT2 "ALIGN=LEFT>$L{'Requests'}</TD>\n";
print FOUT2 "<TD ALIGN=CENTER BGCOLOR=\"#00FFFF\">$reqtot</TD>\n";
if ($locallog == 1 && $localonly != 1) {
print FOUT2 "<TD ALIGN=CENTER>".($reqtot - $reqdomtot)."</TD>\n";
print FOUT2 "<TD ALIGN=CENTER>$reqdomtot</TD>\n";
}
print FOUT2 "</TR>\n<TR>\n";
  if ($ftp_format == 0) {
      print FOUT2 "<TD ";
      print FOUT2 "COLSPAN=2 " if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      print FOUT2 "ALIGN=LEFT>$L{'Accesses'}</TD>\n";
      print FOUT2 "<TD ALIGN=CENTER BGCOLOR=\"#00FF00\">$access</TD>\n";
      if ($locallog == 1 && $localonly != 1) {
	  print FOUT2 "<TD ALIGN=CENTER>".($access - $accessdom)."</TD>\n";
	  print FOUT2 "<TD ALIGN=CENTER>$accessdom</TD>\n";
      }
  }
  if ($ftp_format == 1) {
      $tmp = $totsize_in;
      $tmp = $totsize_in/1024 if ($totsize_in >= 1024);
      $tmp = $totsize_in/(1024*1024) if ($totsize_in >= (1024*1024));
      print FOUT2 "<TD ";
      print FOUT2 "COLSPAN=2 " if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
      print FOUT2 ">$L{'Incoming_traffic'} ";
      print FOUT2 "($L{'Mb'})" if ($totsize_in < 1024);
      print FOUT2 "($L{'Gb'})" if ($totsize_in > 1024 && $totsize_in < (1024*1024));
      print FOUT2 "($L{'Tb'})" if ($totsize_in > (1024*1024));
      print FOUT2 "</TD>\n";
      print FOUT2 "<TD ALIGN=CENTER BGCOLOR=\"#00FF00\">";
      printf FOUT2 "%.2f",$tmp;
      print FOUT2 "</TD>\n";
      if ($locallog == 1 && $localonly != 1) {
	  print FOUT2 "<TD ALIGN=CENTER>-</TD>\n";
	  print FOUT2 "<TD ALIGN=CENTER>-</TD>\n";
      }
  }
  print FOUT2 "</TR><TR>\n";
  $tmp = $totsize;
  $tmp = $totsize/1024 if ($totsize >= 1024);
  $tmp = $totsize/(1024*1024) if ($totsize >= (1024*1024));
  print FOUT2 "<TD ";
  print FOUT2 "COLSPAN=2 " if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help");
  print FOUT2 "ALIGN=LEFT>$L{'Outgoing_traffic'} " if ($ftp_format == 1);
  print FOUT2 "ALIGN=LEFT>$L{'Traffic'} " if ($ftp_format == 0);
  print FOUT2 "($L{'Mb'})" if ($totsize < 1024);
  print FOUT2 "($L{'Gb'})" if ($totsize > 1024 && $totsize < (1024*1024));
  print FOUT2 "($L{'Tb'})" if ($totsize > (1024*1024));
  print FOUT2 "</TD>\n";
  print FOUT2 "<TD ALIGN=CENTER BGCOLOR=\"#CCCCCC\">";
  printf FOUT2 "%.2f",$tmp;
  print FOUT2 "</TD>\n";
  if ($locallog == 1 && $localonly != 1) {
      $tmp = $externesize;
      $tmp = $externesize/1024 if ($totsize >= 1024);
      $tmp = $externesize/(1024*1024) if ($totsize > (1024*1024));
      print FOUT2 "<TD ALIGN=CENTER>";
      printf FOUT2 "%.2f",$tmp;
      print FOUT2 "</TD>\n";
      $tmp = $domsize;
      $tmp = $domsize/1024 if ($totsize >= 1024);
      $tmp = $domsize/(1024*1024) if ($totsize >= (1024*1024));
      print FOUT2 "<TD ALIGN=CENTER>";
      printf FOUT2 "%.2f",$tmp;
      print FOUT2 "</TD>\n";
  }
  print FOUT2 "</TR></TABLE>\n";

#
####

print FOUT2 "</TD><TD VALIGN=TOP ROWSPAN=2>";

### 4ieme tableau

  if ($nbdays != 0) {
print FOUT2 "<TABLE BORDER=0 CELLPADDING=1 BGCOLOR=\"#DDDDDD\" CELLSPACING=3>\n<TR>\n";
print FOUT2 "<TH ALIGN=LEFT><FONT SIZE=+1>$L{'Average'}</FONT></TH>\n";
print FOUT2 "<TD ALIGN=LEFT>$L{'Days'}</TD>\n";
print FOUT2 "</TR>\n<TR>\n";
print FOUT2 "<TD ALIGN=LEFT>$L{'Requests'}</TD>\n";
print FOUT2 "<TD ALIGN=RIGHT>".int($reqtot/$nbdays)."</TD>\n";
print FOUT2 "</TR>\n<TR>\n";
print FOUT2 "<TD ALIGN=LEFT>$L{'Accesses'}</TD>\n";
print FOUT2 "<TD ALIGN=RIGHT>".int($access/$nbdays)."</TD>\n";
print FOUT2 "</TR>\n<TR>\n";
print FOUT2 "<TD ALIGN=LEFT>$L{'Hosts'}</TD>\n";
print FOUT2 "<TD ALIGN=RIGHT>".int($serveruniquetot/$nbdays)."</TD>\n";
print FOUT2 "</TR>\n<TR>\n";
print FOUT2 "<TD ALIGN=LEFT>$L{'Traffic'} ";
$tmp1 = $totsize/$nbdays;
$tmp = $tmp1;
$tmp = $tmp1/1024 if ($tmp1 > 1024);
$tmp = $tmp1/(1024*1024) if ($tmp1 > (1024*1024));
print FOUT2 "($L{'Mb'})" if ($tmp1 < 1024);
print FOUT2 "($L{'Gb'})" if ($tmp1 > 1024 && $tmp1 < (1024*1024));
print FOUT2 "($L{'Tb'})" if ($tmp1 > (1024*1024));
print FOUT2 "</TD>\n";
printf FOUT2 "<TD ALIGN=RIGHT>%.1f</TD>\n",$tmp;
print FOUT2 "</TR>\n</TABLE>\n";
}

###

print FOUT2 "</TD><TD VALIGN=TOP ROWSPAN=2>";

### 3ieme tableau

print FOUT2 "<TABLE BORDER=0 CELLPADDING=1 BGCOLOR=\"#DDDDDD\" CELLSPACING=3>\n<TR>\n";
$tmp_help = "take_account.html";
print FOUT2 "<TH ALIGN=LEFT COLSPAN=4>";
print FOUT2 "<TABLE WIDTH=100% BORDER=0 CELLPADDING=0 CELLSPACING=0><TR>";
  if (-f "$pathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl$tmp_help") {
      print FOUT2 "<TH ALIGN=LEFT BGCOLOR=\"#DDDDDD\"><A HREF=\"javascript:HelpDisplay('$tmp_help')\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$icon_help\" BORDER=0></A></TH>";
  }
print FOUT2 "<TH ALIGN=LEFT><FONT SIZE=+1>$L{'Acces_not_taken_into_account'}</FONT></TH>\n";
print FOUT2 "</TR></TABLE>\n";
print FOUT2 "</TR>\n<TR>\n";
print FOUT2 "<TD COLSPAN=3";
print FOUT2 " ALIGN=LEFT>$L{'Total'} :</TD><TD ALIGN=RIGHT BGCOLOR=\"#00FFFF\">".($loglines - $reqtot)."</TD>\n";
print FOUT2 "</TR>\n<TR>\n";
print FOUT2 "<TD>$L{'Proxy'} (304)</TD><TD ALIGN=RIGHT>$proxy</TD>\n";
print FOUT2 "<TD>$L{'Pages_excluding'}</TD><TD ALIGN=RIGHT>$exclpages</TD>\n";
print FOUT2 "</TR>\n<TR>\n";
print FOUT2 "<TD>$L{'Redirect'} (302)</TD><TD ALIGN=RIGHT>$redirect</TD>\n";
print FOUT2 "<TD>$L{'Hosts_excluding'}</TD><TD ALIGN=RIGHT>$excladdr</TD>\n";
print FOUT2 "</TR>\n<TR>\n";
print FOUT2 "<TD>$L{'Forbidden'} (403)</TD><TD ALIGN=RIGHT>$forbiden</TD>\n";
print FOUT2 "<TD>$L{'Frames_excluding'}</TD><TD ALIGN=RIGHT>$exclframed</TD>\n";
print FOUT2 "</TR>\n<TR>\n";
print FOUT2 "<TD>";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsep$incstatus$htmlext\">" if (-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$incstatus$htmlext");
print FOUT2 "$L{'Not_found'}";
print FOUT2 "</A>" if (-f "$path$lang[$nblang]$dirsep$dirlist$dirsep$incstatus$htmlext");
print FOUT2 " (404)</TD><TD ALIGN=RIGHT>$notfound</TD>\n";
print FOUT2 "<TD>$L{'Robots_excluding'}</TD><TD ALIGN=RIGHT>$exclrobots</TD>\n";
print FOUT2 "</TR>\n</TABLE>\n";

#

print FOUT2 "</TD></TR><TR><TD VALIGN=BOTTOM>";

### 2ieme tableau

print FOUT2 "<TABLE BORDER=0 CELLPADDING=0 BGCOLOR=\"#DDDDDD\" CELLSPACING=3>\n";
print FOUT2 "<TR>\n";
print FOUT2 "<TD>$L{'Number_of_different_pages_used'}</TD>";
print FOUT2 "<TD ALIGN=RIGHT>&nbsp;$pageunique&nbsp;</TD>\n";
print FOUT2 "</TR>\n<TR>\n";
print FOUT2 "<TD>$L{'Number_of_different_sites'}</TD>";
print FOUT2 "<TD ALIGN=RIGHT>&nbsp;$serveruniquetot&nbsp;</TD>\n";
print FOUT2 "</TR>\n";
if ($precision > 2 && $paysunique != 0) {
print FOUT2 "<TR>\n<TD>$L{'Number_of_different_resolved_countries'}</TD>";
print FOUT2 "<TD ALIGN=RIGHT>&nbsp;$paysunique&nbsp;</TD></TR>\n";
}
print FOUT2 "</TABLE>\n";

#

print FOUT2 "</TD></TR></TABLE>\n";
print FOUT2 "</CENTER>\n";

#if ($inc_script == 1) {
#$tmp = $method{'GET'} + $method{'POST'};
#print FOUT2 "<TD>$L{'Total_number_of_scripts'} :</TD><TD ALIGN=RIGHT>$tmp\n";
#print FOUT2 "</TR><TR>\n";
#}

print FOUT2 "<P><HR><P>\n";

print FOUT2 "<CENTER>\n";
print FOUT2 "<TABLE WIDTH=100% CELLPADDING=5 CELLSPACING=5 BORDER=1>\n";
print FOUT2 "<TR>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=CENTER>\n";

### pointeurs sur les sites, pages, script et trafic

print FOUT2 "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>\n";
print FOUT2 "<TR>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$filesites\"><IMG WIDTH=34 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_hosts\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirsite$dirsepurl$filesites\">$L{'Hosts'}</A>\n";
print FOUT2 "</FONT></TD>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirpage$dirsepurl$filepages\"><IMG WIDTH=34 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_pages\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirpage$dirsepurl$filepages\">$L{'Pages'}</A>\n";
print FOUT2 "</FONT></TD>\n";
if ($precision > 2) {
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filetype$htmlext\"><IMG WIDTH=36 HEIGHT=28 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_filetype\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filetype$htmlext\">$L{'Filetype'}</A>\n";
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
}
if ($inc_script == 1) {
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirscript$dirsepurl$filescript\"><IMG WIDTH=34 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_script\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirscript$dirsepurl$filescript\">$L{'Scripts'}</A>\n";
print FOUT2 "</FONT></TD>\n";
}
print FOUT2 "</TR>\n";

if ($precision > 2) {
print FOUT2 "<TR>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filerepert\"><IMG WIDTH=34 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_dir\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filerepert\">$L{'Directories'}</A>\n";
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
if ($paysunique != 0) {
print FOUT2 "<A HREF=\"..$dirsepurl$dirpays$dirsepurl$filepays\"><IMG WIDTH=30 HEIGHT=30 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_countries\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirpays$dirsepurl$filepays\">$L{'Countries'}</A>\n";
print FOUT2 "</FONT>\n";
}
print FOUT2 "</TD>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$dirdownload$htmlext\"><IMG WIDTH=35 HEIGHT=30 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_pie\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$dirdownload$htmlext\">$L{'Download'}</A>\n";
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$dirtraffic$htmlext\"><IMG WIDTH=13 HEIGHT=35 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_traffic\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$dirtraffic$htmlext\">$L{'Traffic'}</A>\n";
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
print FOUT2 "</TR>\n";
}

print FOUT2 "</TABLE>\n";

###

print FOUT2 "</TD>\n";
print FOUT2 "<TD ROWSPAN=3 ALIGN=CENTER VALIGN=CENTER>\n";

### pointeurs sur les heures,jours, semaines et mois

print FOUT2 "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>\n";

print FOUT2 "<TR>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$file_now\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$file_now");
print FOUT2 "<IMG WIDTH=34 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_duree\" BORDER=0>";
print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$file_now");
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$file_now\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$file_now");
print FOUT2 "$L{'Real_time'}";
print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$file_now");
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
print FOUT2 "</TR><TR>\n";

print FOUT2 "<TR>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$filehour\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
print FOUT2 "<IMG WIDTH=26 HEIGHT=29 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_hours\" BORDER=0>";
print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$filehour\">" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
print FOUT2 "$L{'Hours'}";
print FOUT2 "</A>\n" if (-e "$path$lang[0]$dirsep$dirdate$dirsep$filenamehour");
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
print FOUT2 "</TR><TR>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$fileday\"><IMG WIDTH=75 HEIGHT=42 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_days\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$fileday\">$L{'Days'}</A>\n";
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
print FOUT2 "</TR><TR>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$fileweek\">" unless ($nbdays < 14);
print FOUT2 "<IMG WIDTH=80 HEIGHT=50 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_weeks\" BORDER=0>";
print FOUT2 "</A>\n" unless ($nbdays < 14);
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$fileweek\">" unless ($nbdays < 14);
print FOUT2 "$L{'Weeks'}";
print FOUT2 "</A>" unless ($nbdays < 14);
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
print FOUT2 "</TR><TR>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$filemonth\">" if ($nbdays > 30 || $count_month > 0);
print FOUT2 "<IMG WIDTH=33 HEIGHT=33 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_months\" BORDER=0>";
print FOUT2 "</A>\n" if ($nbdays > 30 || $count_month > 0);
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirdate$dirsepurl$filemonth\">" if ($nbdays > 30 || $count_month > 0);
print FOUT2 "$L{'Months'}";
print FOUT2 "</A>" if ($nbdays > 30 || $count_month > 0);
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
print FOUT2 "</TR>\n";
print FOUT2 "</TABLE>\n";

###

print FOUT2 "</TD>\n";
print FOUT2 "</TR>\n";
print FOUT2 "<TR>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=CENTER>\n";

### pointeurs sur les erreurs, references et fureteurs

if ((-e "$path$I$dirsep$dirlist$dirsep$error") || (-e "$path$I$dirsep$dirlist$dirsep$refer") || (-e "$path$I$dirsep$dirlist$dirsep$agent")) {
print FOUT2 "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>\n";
print FOUT2 "<TR>\n";
if (-e "$path$I$dirsep$dirlist$dirsep$error") {
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$error\"><IMG WIDTH=42 HEIGHT=40 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_error\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$error\">$L{'Errors'}</A>\n";
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
}
if (-e "$path$I$dirsep$dirlist$dirsep$agent") {
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$agent\"><IMG WIDTH=37 HEIGHT=39 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_agent\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$agent\">$L{'Browsers'}</A>\n";
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
}
if (-e "$path$I$dirsep$dirlist$dirsep$refer") {
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$refer\"><IMG WIDTH=34 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_refer\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$refer\">$L{'Referer'}</A>\n";
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
}
print FOUT2 "</TR>\n";
print FOUT2 "</TABLE>\n";
}

###

print FOUT2 "</TD>\n";
print FOUT2 "</TR>\n";
print FOUT2 "<TR>\n";
print FOUT2 "<TD ALIGN=CENTER VALIGN=CENTER>\n";

### pointeurs sur les sessions et documents, virus

#if ((-e "$path$I$dirsep$dirdocument$dirsep$menu") || (-e "$path$I$dirsep$dirsession$dirsep$filesession") || (-e "$path$I$dirsep$dirlist$dirsep$filevirus") || ($virtualfilter eq '' && $virtualunique != 0)) {
if ((-e "$path$I$dirsep$dirdocument$dirsep$menu") || (-e "$path$I$dirsep$dirsession$dirsep$filesession") || ($nb_virus != 0) || ($virtualfilter eq '' && $virtualunique != 0)) {
print FOUT2 "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=5>\n";
print FOUT2 "<TR>\n";
if (-e "$path$I$dirsep$dirdocument$dirsep$menu") {
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirdocument$dirsepurl$menu\"><IMG WIDTH=53 HEIGHT=33 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_doc\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirdocument$dirsepurl$menu\">$L{'Documents'}</A>\n";
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
}
if (-e "$path$I$dirsep$dirsession$dirsep$filesession") {
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirsession$dirsepurl$filesession\"><IMG WIDTH=38 HEIGHT=39 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_session\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirsession$dirsepurl$filesession\">$L{'Sessions'}</A>\n";
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
}

if ($nb_virus != 0) {
#if (-e "$path$I$dirsep$dirlist$dirsep$filevirus") {
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filevirus\"><IMG WIDTH=28 HEIGHT=34 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_virus\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filevirus\">$L{'Virus'}</A>\n";
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
}
if ($virtualfilter eq '' && $virtualunique != 0) {
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filevirtual\"><IMG WIDTH=34 HEIGHT=33 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_virtual\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filevirtual\">$L{'Destination'}</A>\n";
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
}
if ($squid_format == 1) {
print FOUT2 "<TD ALIGN=CENTER VALIGN=BOTTOM>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirproxy$dirsepurl$filesquid\"><IMG WIDTH=35 HEIGHT=35 SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_squid\" BORDER=0></A>\n";
print FOUT2 "<BR><FONT SIZE=+1>\n";
print FOUT2 "<A HREF=\"..$dirsepurl$dirproxy$dirsepurl$filesquid\">$L{'Proxy'}</A>\n";
print FOUT2 "</FONT>\n";
print FOUT2 "</TD>\n";
}

print FOUT2 "</TR>\n";
print FOUT2 "</TABLE>\n";
}

##

print FOUT2 "</TD>\n";
print FOUT2 "</TR>\n";
print FOUT2 "</TABLE>\n";

print FOUT2 "</CENTER>\n";

print FOUT2 "<BR>\n";

print FOUT2 "<TABLE BORDER=0 WIDTH=100\%><TR>\n";
print FOUT2 "<TD ALIGN=LEFT>";
#print FOUT2 "<I><FONT SIZE=2>&#169; Copyright 1995/2003 <A HREF=\"mailto:domisse\@w3perl.com\">Laurent DOMISSE</A></FONT></I>";
print FOUT2 "</TD>\n";
print FOUT2 "<TD ALIGN=RIGHT><I><FONT SIZE=2>";
print FOUT2 "<A HREF=\"..$dirsepurl$dirlist$dirsepurl$filecpu\">" if (-e "$path$I$dirsep$dirlist$dirsep$filecpu");
print FOUT2 "$L{'Stats'}";
print FOUT2 "</A>" if (-e "$path$I$dirsep$dirlist$dirsep$filecpu");
print FOUT2 " $L{'computed_with'} <A HREF=\"..$dirsepurl..$dirsepurl$linkpathinit$dirdocs$dirsepurl$help\">W3Perl $version</A> </FONT></I></TD>\n";
print FOUT2 "</TR></TABLE>\n";
print FOUT2 "</BODY></HTML>\n";
}

#################################################################
####              Detect W3C logfile format               #######
#################################################################

sub detect_w3c_logformat {
    local($line) = @_;
    local(@tmp,$tmp,$tmpa,$struct_logfile);

    undef %fields_logfile;

       if ($line =~ /^\#Fields:/) {
	   $struct_logfile = '';
	   ($tmpa,@tmp) = split(/\s+/,$line);
	   foreach $tmp (@tmp) {
	       $struct_logfile .= $w3c_struct_logfile{$tmp}." ";
	   }
       }
    @logfile_fields = split(/\s+/,$struct_logfile);

    for ($i=0;$i<=$#logfile_fields;$i++) {
	$fields_logfile{$logfile_fields[$i]} = $i;
    }

    $iis_format = 1;
    $type_serveur = 1;
    @date_string = split(/%/,$date_format);

    $logfile_sep = ", " if ($logfile_fields[1] eq "%login"); # IIS 3
    $logfile_sep = " " if ($logfile_fields[1] ne "%login");  # IIS 4, 5

    if ($struct_logfile =~ "%referer" && $struct_logfile =~ "%agent") {
	$referlog = $prefixlog; # for extented common logfile (NCSA > 1.4)
	$agentlog = $prefixlog; # for extented common logfile (NCSA > 1.4)
    }
    return $struct_logfile;

}

#################################################################
####                Find the last logfile                 #######
#################################################################

sub find_last_log {
    local($fileroot,$filelog) = @_;
#    local($re,$i,$j,$yday_max,$yday,$tmp3,$field_re,$tmp);
#    local($year,$month,$day,$hour,$min,$sec);

    opendir(SOURCEDIR,$fileroot) || die "Couldn't open directory $fileroot !\n";
    local(@filenames) = readdir(SOURCEDIR);
    closedir(SOURCEDIR);

    $re = 0;
    for ($i=0;$i<$#filenames;$i++) {
	if ($filenames[$i] =~ /$filelog$compressed_sep_fields[1]/) {
	    $tab_re[$re] = $filenames[$i];
	    $re++;
	}
    }

    $yday_max = 0;

    for ($j=0;$j<$re;$j++) {
	for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
	    $field_re = $compressed_logfile_fields[$i];
	    $tmp = $compressed_sep_fields[$i];
	    $tab_re[$j] =~ s/$filelog//;
#	    $tab_re[$j] =~ s/$filelog// if ($field_re eq "%prefixlog" || $field_re eq "%errorlog");
	
	    if ($field_re eq "%year") {
		$tab_re[$j] =~ s/^(\d\d\d\d)//;
		$year_re[$j] = $1;
	    }
	    if ($field_re eq "%smallyear") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$year_re[$j] = $smallyear2_today.$1 if ($1 <= $smallyear_today);
		$year_re[$j] = ($smallyear2_today-1).$1 if ($1 > $smallyear_today);
	    }
	    if ($field_re eq "%month") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$month_re[$j] = $1;
	    }
	    if ($field_re eq "%lettermonth") {
		$tab_re[$j] =~ s/^(\w\w\w)//;
		$lettermonth_re[$j] = $month_equiv{$1};
	    }
	    if ($field_re eq "%day") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$day_re[$j] = $1;
	    }
	    if ($field_re eq "%hour") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$hour_re[$j] = $1;
	    }
	    if ($field_re eq "%min") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$min_re[$j] = $1;
	    }
	    if ($field_re eq "%sec") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$sec_re[$j] = $1;
	    }
	    $tab_re[$j] =~ s/$tmp// if ($tmp ne '');
	}
	$jour = "$day_re[$j] $month_re[$j] $year_re[$j]";
	if ($jour =~ /\d\d \d\d \d\d\d\d/) {
	    $yday = &nbday($jour);
	    $tab_re[$j] = $jour;
	    if ($yday > $yday_max) {
		$yday_max = $yday;
		$tmp3 = $j;
	    }
	}
    }

    $year = $year_re[$tmp3];
    $month = $month_re[$tmp3];
    $day = $day_re[$tmp3];
    $hour = $hour_re[$tmp3];
    $min = $min_re[$tmp3];
    $sec = $sec_re[$tmp3];

    $file_re = $fileroot;
    for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
	$compressed_logfile_fields[$i] =~ s/\%/\$/;
	$file_re .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
    }

    return $file_re;

}

#################################################################
####               Find the first logfile                 #######
#################################################################

sub find_first_log {
    local($fileroot,$filelog) = @_;
#    local($re,$i,$j,$yday_min,$yday,$tmp3,$field_re,$tmp);
#    local($year,$month,$day,$hour,$min,$sec);

    opendir(SOURCEDIR,$fileroot) || die "Couldn't open directory $fileroot !\n";
    local(@filenames) = readdir(SOURCEDIR);
    closedir(SOURCEDIR);

    $re = 0;
    for ($i=0;$i<$#filenames;$i++) {
	if ($filenames[$i] =~ /$filelog$compressed_sep_fields[1]/) {
	    $tab_re[$re] = $filenames[$i];
	    $re++;
	}
    }

    $yday_min = &nbday($today);

    for ($j=0;$j<$re;$j++) {
	for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
	    $field_re = $compressed_logfile_fields[$i];
	    $tmp = $compressed_sep_fields[$i];
	    $tab_re[$j] =~ s/$filelog//;
#	    $tab_re[$j] =~ s/$filelog// if ($field_re eq "%prefixlog" || $field_re eq "%errorlog");
	
	    if ($field_re eq "%year") {
		$tab_re[$j] =~ s/^(\d\d\d\d)//;
		$year_re[$j] = $1;
	    }
	    if ($field_re eq "%smallyear") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$year_re[$j] = $smallyear2_today.$1 if ($1 <= $smallyear_today);
		$year_re[$j] = ($smallyear2_today-1).$1 if ($1 > $smallyear_today);
	    }
	    if ($field_re eq "%month") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$month_re[$j] = $1;
	    }
	    if ($field_re eq "%lettermonth") {
		$tab_re[$j] =~ s/^(\w\w\w)//;
		$lettermonth_re[$j] = $month_equiv{$1};
	    }
	    if ($field_re eq "%day") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$day_re[$j] = $1;
	    }
	    if ($field_re eq "%hour") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$hour_re[$j] = $1;
	    }
	    if ($field_re eq "%min") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$min_re[$j] = $1;
	    }
	    if ($field_re eq "%sec") {
		$tab_re[$j] =~ s/^(\d\d)//;
		$sec_re[$j] = $1;
	    }
	    $tab_re[$j] =~ s/$tmp// if ($tmp ne '');
	}
	$jour = "$day_re[$j] $month_re[$j] $year_re[$j]";
	if ($jour =~ /\d\d \d\d \d\d\d\d/) {
	    $yday = &nbday($jour);
	    $tab_re[$j] = $jour;
	    if ($yday < $yday_min) {
		$yday_min = $yday;
		$tmp2 = $j;
	    }
	}
    }

    $year = $year_re[$tmp2];
    $month = $month_re[$tmp2];
    $day = $day_re[$tmp2];
    $hour = $hour_re[$tmp2];
    $min = $min_re[$tmp2];
    $sec = $sec_re[$tmp2];

    $file_re = $fileroot;
    for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
	$compressed_logfile_fields[$i] =~ s/\%/\$/;
	$file_re .= eval($compressed_logfile_fields[$i]).$compressed_sep_fields[$i];
    }

    return $file_re;
}

#################################################################
####             Create stats ouput directories           #######
#################################################################

sub MakeDirectories {
    local($i,$j,$tmp,$tmp2);

    # directory a la racine

    $tmp2 = 1;
    $tmp = $path;
    chop($tmp);
    $tmp2 = mkdir ($tmp,0775) unless -d $tmp;

    # en cas d'echec, on essaye un repertoire en dessous

    $i = 0;
    while ($tmp2 == 0 && $tmp ne '') {
	$i++;
	$tmpold[$i] = $tmp;
	$tmp = substr($tmp,0,rindex($tmp,$dirsep)+1);
	chop($tmp);
	$tmp2 = mkdir ($tmp,0775) unless -d $tmp;
    }

    if ($tmp eq '') {
	print "<FONT COLOR=\"#FF0000\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "Problem creating directory $path\n";
	print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "Check write permission\n";
	print "</FONT>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	exit;
    }


    if ($i != 0) {
	for ($j=$i;$j>$0;$j--) {
	    $tmp = $tmpold[$j];
	    $tmp2 = mkdir ($tmp,0775) unless -d $tmp;
	}
    }

    if ($tmp2 == 0) {
	print "Unable to create $path\n";
	exit;
    }

    # repertoire tmp en 777

    $tmp = umask(0);
    $dir = $path.$dirtmp;
    mkdir ($dir,0777) unless -d $dir;

    umask($tmp);
    $dir = $path.$dirinc;
    mkdir ($dir,0775) unless -d $dir;

    $dir = $path.$dirdata;
    mkdir ($dir,0775) unless -d $dir;

    $dir = $path.$dirgraph;
    mkdir ($dir,0775) unless -d $dir;

# ML

    for ($nblang=0;$nblang<=$#lang;$nblang++) {

	$dir = $path.$lang[$nblang];
	mkdir ($dir,0775) unless -d $dir;
	
	$dir = $path.$lang[$nblang].$dirsep.$dirframe;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirpays;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirsite;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirlist;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirscript;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirpage;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirdate;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirsession;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirdocument;
	mkdir ($dir,0775) unless -d $dir;

	$dir = $path.$lang[$nblang].$dirsep.$dirdomain;
	mkdir ($dir,0775) unless -d $dir;

	if ($squid_format == 1) {
	    $dir = $path.$lang[$nblang].$dirsep.$dirproxy;
	    mkdir ($dir,0775) unless -d $dir;
	}

#$dir = $path.$lang[$nblang].$dirsep.$dirdays;
#mkdir ($dir,0775) unless -d $dir;
    }
}

#################################################################
####              Get full agent string                   #######
#################################################################

sub GetAgentString {
    local($f,$i) = @_;
    local($tmpi,$tt1);

    $f3 = '';

    if ($f !~ m/\"/) {
	$f2 = '';
	$tmpi = $i + 1;
	$f3 = $line_log[$tmpi]." ";
	while ($f3 !~ /\-\s+/ && $f3 !~ /http:\/\//i && $f3 ne ' ') {
	    $f2 .= $f3;
	    $tmpi++;
	    $f3 = $line_log[$tmpi]." ";
#	    $f3 = $line_log[$tmpi++]." ";
	}
	$f .= " ".$f2;
    }

    if ($type_serveur == 0 && $f3 eq '') {    
	while ((rindex($f,'"')+1) != length($f) && ($f !~ /\n/)) {
	    $i++;
	    $line_log[$i] = "[".$line_log[$i] if ($line_log[$i] =~ /\]/);
	    $f .= " ".$line_log[$i];
	    $tt = rindex($f,'"')+1;
	    $tt1 = length($f);
	    if ($i > 200) {
		print STDERR "$_ \n";
		print STDERR "\n\nThe agent string seems to be very long ... check !\n";
	    }
	}
    }

    $f =~ s/\+/ /g if ($type_serveur == 1);
    $f =~ s/^A://;
    $f =~ s/\n//;
    $f =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    next if ($f eq '');

    chop($f);
    return $f;
}

#################################################################
####            Use help popup javascript                 #######
#################################################################

sub popup_help {
    local(*FOUT) = @_;
    print FOUT "<script LANGUAGE=\"Javascript\">\n";
    print FOUT "var popup_help = null;\n";
    print FOUT "function HelpDisplay(file) {\n";
    print FOUT "xwin = screen.width/2;\n";
    print FOUT "ywin = screen.height/3;\n";
    print FOUT "popup_help = window.open(\"\",\"popDialogHelp\",\"height=\"+ywin+\",width=\"+xwin+\",scrollbars=yes\")\n";
    print FOUT "popup_help.location.href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirhelp$dirsep$I$dirsepurl\"+file;\n";
    print FOUT "popup_help.document.close();\n";
    print FOUT "popup_help.focus();\n";
    print FOUT "}\n";
    print FOUT "</SCRIPT>\n";
} 

#################################################################
####         sort an associative array by value           #######
#################################################################

# convert YYYYMMDD to DD/Mmm/YYYY

sub aff_date {
    local($date) = @_;
    local($string);

    $string = substr($date,6,2)."/".$month_nb[substr($date,4,2)-1]."/".substr($date,0,4);
    return $string;
}

# convert DD/Mmm/YYYY into YYYYMMDD

sub encode_date {
    local($date) = @_;
    local($string,$day,$month,$year);

    ($day,$month,$year) = split(/\//,$date);

    $string = "$year$month_equiv{$month}$day";
    return $string;
}

sub reverse_sort_by_value {
        local(*x) = @_;
        sub _by_value { $x{$a} <=> $x{$b}; } 
        reverse sort _by_value keys %x;
    } 

#sub reverse_sort_by_string {
#        local(*x) = @_;
#        sub _by_value { $x{$a} cmp $x{$b}; } 
#        reverse sort _by_value keys %x;
#    } 

#################################################################
####                Exclude robot from a list             #######
#################################################################

sub ExcludeRobot {
    local($agent) = @_;
    local($bot,$foundrobot);

    $foundrobot = 0;
    if (!$TmpRobot{$agent}) {
	foreach $bot (keys %RobotHash) {
	    if ($agent =~ /$bot/i) {
		$TmpRobot{$agent} = "$bot";
		$foundrobot = 1;
		last;
	    }
	}
    } else {
	$foundrobot = 1 if ($TmpRobot{$agent} ne '');
    }
#    $TmpRobot{$agent} = '-' if ($foundrobot == 0);
    return $foundrobot;
}

1;
