#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                    Language Script                             #####
####                     (http server)                              #####
####                                                                #####
####    domisse@w3perl.com                   version 02/05/2003     #####
####                                                                #####
#########################################################################

# Look for YYY string for new or updated strings

%LangDE = (
"Cached_files", "Cached files",
"Cached_trafic", "Cached trafic",
"Downloaded_files", "Downloaded files",
"Downloaded_trafic", "Downloaded trafic",
"milliseconds", "ms",
"Stats_over", "Stats over",
"updated_every", "updated every",
"with_an_integration_time_of", "with an integration time of",
"Real_time","Real time",
"Abort","Abort",
"Status_code","Status code",
"Size","Size",
"Download_not_completed","Download not completed",
"Outgoing_traffic", "Outgoing traffic",
"Incoming_traffic", "Incoming traffic",
"Virus", "Virus",
"virus", "virus",
"internal_pages", "YYYinternal pages",
"Internal_pages", "YYYInternal pages",
"Accesses_only", "YYYAccesses only",
"accesses", "YYYaccesses",
"First_line_is_number_of_files_according_to_seuil", "YYYFirst line is the number of files according to the threshold choosen",
"Second_line_is_number_of_accesses_according_to_seuil", "YYYSecond line is the number of accesses according to the threshold choosen", 
"percentage_relative_to_number_without_seuil", "YYYpercentage is relative to number without threshold",
"Gb", "Gb",
"Tb", "Tb",
"most_successful_bookmark", "h&auml;ufigstes Lesezeichen",
"Bookmarked_page", "Favoriten",
"Difference", "Differenz",
"Minimum", "Min",
"Maximum", "Max",
"Only_files", "Nur Dateien",
"Filetype", "Dateityp",
"28800_modem", "28800 Modem",
"A_description" , "Eine Beschreibung",
"About_months" , "Monatstabelle",
"About_weeks" , "Wochentabelle", 
"Absolute_links", "Absolute Links",
"Acces_not_taken_into_account", "Nicht ber&uuml;cksichtigte Zugriffe",
"Accesses" , "Zugriffe", 
"All_html_pages_requests", "S&auml;mtliche Zugriffe auf HTML Seiten",
"All_images_requests", "S&auml;mtliche Zugriffe auf Grafiken",
"All_requests" , "Alle Zugriffe",
"All_sites" , "Alle Gegenstellen",
"At", "Um",
"Average_CPU", "Durchschnittliche CPU Leistung",
"Average", "Durchschnitt",
"Average_is_black", "Durchschnitt ist in schwarzer Schrift",
"Average_on_hours_and_days", "Durchschnitt in Stunden und Tagen",
"Average_pages_by_session", "durchschnittlich gelesene Seiten pro Session",
"Average_session_time", "durchschnittlich verbrachte Zeit pro Session",
"Average_reading_time_per_page", "durchschnittlich verbrachte Lesezeit",
"Back", "Zur&uuml;ck",
"Background", "Hintergrund",
"Bad_links", "Tote Links",
"Blue_line_is_average", "Blaue Linie = Durchschnitt",
"Browser" , "Browser",
"Browsers" , "Browser",
"Browsers_used" , "Benutzte Browser",
"CPU", "CPU",
"Cgi-bin", "cgi-bin",
"Conn_Mach" , "Verbundene Maschinen",
"Connection_time", "Verbindungszeit",
"Correct_size_taken_from_image", "Korrekte Gr&ouml;sse der Grafik",
"Countries", "L&auml;nder", 
"Data", "Daten",
"Data_traffic_by_weeks" , "Transfer nach Wochen",
"Data_unit_Kb" , "Kilobytes",
"Data_unit_Mb" , "Megabytes",
"Data_unit_octet" , "Bytes",
"Date" , "Datum",
"Days", "Tage", 
"Decrease_over_the_previous_day","Verminderung gegen&uuml;ber dem Vortag",
"Directories" , "Verzeichnisse",
"Directories_graphs" , "Verzeichnisse grafisch",
"Docs" , "Dokumentation",
"Documents" , "Dokumente",
"DomReq" , "Domain Anfragen", 
"Domain", "Domain",
"Domain_Hosts" , "Domain Hosts",
"Download", "Download", 
"Downloading_time", "Downloadzeit",
"Errors" , "Fehler",
"Error", "Fehler",
"Evolution_of", "Auswertung der",
"File", "Datei",
"Forbidden", "Unzul&auml;ssig",
"Found_in", "Gefunden in",
"Frames", "Frames",
"Frames_excluding", "Ohne Frames",
"Global_access", "Globaler Zugriff",
"Graphic" , "Grafik",
"Graphs_for" , "Grafik f&uuml;r",
"Graphs_for_dir" , "Grafik f&uuml;r das Verzeichnis",
"HTML_files", "HTML Dateien",
"Histogram_about_average_request", "Histogramm der durchschnittlichen Zugriffe",
"Histogram_sessions", "Histogramm der Sessions",
"Hosts", "Hosts",
"Hosts_excluding", "Nicht ber&uuml;cksichtigte Hosts",
"Hosts_from" , "Hosts von",
"Hour" , "Stunde", 
"Hours" , "Stunden", 
"Image", "Grafik", 
"Images", "Grafiken",
"Images_histogram", "Histogramm der Grafiken",
"Images_never_used", "Ungenutzte Grafiken",
"Increase_over_the_previous_day", "Steigerung gegen&uuml;ber dem Vortag",
"Index", "Index",
"Index_pages", "Seiten ohne Index",
"Inside" , "Intern",
"Kb" , "Kb", 
"Kbytes" , "Kilobytes", 
"Keywords", "Suchbegriffe",
"Language" , "English",
"Last_occurence" , "Letzte Ausf&uuml;hrung",
"Last_try", "Letzter Versuch",
"Legend_in_bracket", "Legende in Klammern",
"Level", "Level",
"Lines_processed", "verarbeitete Zeilen",
"Link", "Link",
"Links", "Links", 
"Links_histogram", "Links Histogramm",
"ListOf" , "Liste der",
"ListOfSites" , "Liste der Gegenstellen",
"List_of", "Liste der",
"List_of_unresolved_hosts", "Nicht erkannte Hosts",
"Login", "Login", 
"Longest_external_session", "L&auml;ngste externe Session",
"Longest_local_session", "L&auml;ngste lokale Session",
"Longest_session", "L&auml;ngste Session",
"Mach_Dom" , " Rechner von Domain", 
"Mb" , "Mb",
"Mbytes" , "Megabytes",
"Method", "Methode",
"Mhosts" , "Hosts",
"Misc", "Diverses",
"MonthByMonth" , "Von Monat zu Monat", 
"Month_of" , "Monat von ", 
"Month" , "Monat", 
"Months" , "Monate", 
"More_Precise" , "detaillierter",
"MostSuccesf" , "erfolgreichster",
"Multiple_sessions", "Multiple Sessions",
"New_country", "Neue L&auml;nder",
"New_HTML_files", "Neue HTML Dateien",
"New_Hosts" , "Neue Hosts",
"New_Mach" , "Neue Maschinen", 
"Newest_pages", "Neue Seiten",
"Newest_pages_histogram", "Histogramm neuer Seiten",
"News" , "Neuigkeiten",
"NoReq" , "Anzahl der Anfragen",
"No_Ttl_Req_Mnth" , "Anzahl totaler Anfragen pro Monat",
"No_Ttl_Req_Week" , "Anzahl totaler Anfragen pro Woche",
"No_login", "Zugriffe ohne Login",
"No_modification", "Keine &Auml;nderung",
"No_request", "Keine Anfragen get&auml;tigt",
"No_robot_session", "Kein Zugriff von Suchmaschinen gefunden",
"No_title", "Kein Titel",
"Not_found", "Nicht gefunden",
"Number" , "Anzahl",
"Number_of" , "Anzahl von", 
"Number_of_HTML_files", "Anzahl der HTML Dateien",
"Number_of_different_sites" , "Anzahl unterschiedlicher Gegenstellen",
"Number_of_different_resolved_countries" , "Anzahl unterschiedlicher L&auml;nder",
"Number_of_different_pages_used" , "Anzahl unterschiedlicher Seiten",
"Number_of_pages_read", "Anzahl gelesener Seiten",
"Number_of_req_by_weeks" , "Anzahl Anfragen pro Woche",
"Number_of_requests", "Anzahl Anfragen",
"Number_of_visits", "Anzahl Besuche",
"OS" , "System",
"OS_used1" , "Die",
"OS_used2" , "genutzten Betriebssysteme",
"Occurence" , "Vorkommen",
"On", "Ein", 
"Only_HTML_files_itself", "Nur die Gewichtung der HTML Dateien",
"Only_directories", "Nur Verzeichnisse",
"Only_first", "Nur die ersten",
"Only_hosts", "Nur Hosts",
"Only_pages", "Nur Seiten",
"Only_scripts", "Nur Scripte",
"Only_time_session_upper", "Nur Sessions l&auml;nger als",
"Others" , "Andere",
"Outside" , "Extern",
"Page", "Seite", 
"Page_read", "Gelesene Seiten",
"Page_reading_time_histogram", "Histogramm der Lesezeit von HTML Seiten",
"Pages", "Seiten",
"Pages_excluding", "Nicht ber&uuml;cksichtigte Seiten", 
"Pages_never_used", "Unbenutzte Seiten",
"Percentage" , "Prozentual",
"Proxy", "Proxy",
"Reading_time", "Lesezeit",
"Reading_time_sessions", "Sessions mit Lesezeit",
"Redirect", "Umgeleitet",
"References_for" , "Referenzen f&uuml;r",
"Referer" , "Referer",
"Referer_about" , "Referer &uuml;ber",
"Referer_on" , "Referer auf",
"Referer_pages2" , "Referer Seiten",
"Request" , "Anfrage", 
"Requests" , "Anfragen", 
"Robots_excluding", "Nicht ber&uuml;cksichtigte Suchmaschinen",
"Robot_name", "Suchmaschinenname",
"Robot_session_exclude", "Suchmaschinen sind nicht ber&uuml;cksichtigt",
"Same_over_the_previous_day", "Selbige wie am Vortag",
"Same_title", "Selber Titel",
"Scripts", "Skripte",
"Search_engine", "Suchmaschine",
"Send_me_an", "Senden Sie mir eine",
"entry_pages" , "YYYentry pages",
"exit_pages" , "YYYexit pages",
"Entry_pages" , "YYYEntry pages",
"Exit_pages" , "YYYExit pages",
"Server_tree", "Server Baum",
"Session", "Session",
"Session_cut1", "Sofern eine Session l&auml;ger dauert als einen Tag, wird sie zum ersten Tag dazugerechnet",
"Session_cut2", "Sofern eine Session &uuml;ber einen Tag geht, k&ouml;nnte die Auswertung fehlerhaft sein",
"Session_time", "Session Zeit",
"Session_title", "Session Titel",
"Sessions" , "Sessions",
"Sessions_from", "Sessions von",
"Sorted_countries_list", "Sortierte L&auml;nder Liste",
"Sorted_virtual_server_list", "Sortierte Virtual Server Liste",
"Speed", "Laufzeit",
"Stats_about_CPU", "CPU Statistik",
"Stats" , "Statistik", 
"Stats_aboutMnth" , "Statistik &uuml;ber",
"Stats_about_HTML_files", "Statistik &uuml;ber HTML Dateien",
"Stats_about_HTML_files_weight", "Statistik &uuml;ber die Gewichtung von HTML Dateien",
"Stats_about_alt", "Statistik &uuml;ber ALT Tags",
"Stats_about_errors" , "Fehlerstatistik", 
"Stats_about_host" , "Hoststatistik", 
"Stats_about_hosts", "Hoststatistik",
"Stats_about_images", "Grafikstatistik",
"Stats_about_internal_links", "Statistik der internen Links",
"Stats_about_login", "Loginstatistik",
"Stats_about_months" , "Monatsstatistik", 
"Stats_about_robots_sessions", "Suchmaschinenstatistik",
"Stats_about_session_length", "Statistik &uuml;ber die L&auml;nge der Sessions",
"Stats_about_sessions", "Sessionstatistik",
"Stats_about_visits", "Besucherstatistik",
"Stats_about_virtual_servers", "Statistik der Virtual Server",
"Stats_about_weeks" , "Wochentatistik", 
"Stats_about_width", "Statistik &uuml;ber L&auml;nge und H&ouml;he",
"Stats_aboutlastdays1" , "Statistik der letzten",
"Stats_aboutlastdays2" , "Tage",
"String", "String",
"Successful_pages" , "Erfolgreiche Seiten",
"Summary", "Summe",
"Symbolic_links", "Symbolische Links",
"Tab_about_lastdays1" , "Daten Tabelle &uuml;ber die letzten",
"Tab_about_lastdays2" , "Tage",
"Table" , "Tabelle", 
"Text" , "Text",
"Textual_version" , "Text Version",
"The_Top", "Die Top",
"Time", "Zeit",
"Total", "Total",
"Total_HTML_access", "Gesamtanzahl von HTML Zugriffen",
"Total_data_sent" , "Total gesendete Daten",
"Total_number_of_directories", "Gesamtanzahl der Verzeichnisse",
"Total_number_of_html_files", "Gesamtanzahl der HTML Dateien",
"Total_number_of_images", "Gesamtanzahl der Grafiken",
"Total_number_of_images_in_files", "Gesamtanzahl der Grafiken in HTML Dateien",
"Total_number_of_links", "Gesamtanzahl der Links",
"Total_number_of_requests" , "Gesamtanzahl der Anfragen",
"Total_number_of_robot_session", "Gesamtanzahl der Zugriffe von Suchmaschinen",
"Total_number_of_scripts", "Gesamtanzahl der Skripte",
"Total_number_sessions", "Gesamtanzahl der Sessions",
"Total_traffic" , "Gesamter Transfer",
"Traffic" , "Transfer", 
"Traffic_about" , "&Uuml;ber Transfer",
"Traffic_statistics" , "Transferstatistik",
"Tree", "Baum",
"Useless_pages", "&Uuml;berfl&uuml;ssige Seiten",
"Users" , "User",
"Virtual_servers", "Virtuelle Server",
"You_should_add", "Sie sollten hinzuf&uuml;gen",
"Web_size", "Web Gr&ouml;sse",
"Week" , "Woche", 
"Weeks" , "Wochen", 
"Weight_HTML_files_histogram", "Histogramm der Gewichtung der HTML Dateien",
"Weight_of_HTML_files", "Gewichtung der HTML Seiten",
"With" , "L&auml;nge", 
"about" , "&uuml;ber", 
"about_hours_and_days", "&uuml;ber Stunden und Tage",
"absolute_links", "Absolute Links",
"added_pages", "Sofern Sie eine Ihrer Seiten hier hinzuf&uuml;gen m&ouml;chten",
"all_sites", "Alle Gegenstellen",
"among" , "von", 
"and", "und",
"are_printed", "sind aufgef&uuml;hrt",
"average_HTML_accesses", "Durchschnittliche Anzahl der HTML Zugriffe",
"bad_links", "Tote Links",
"by", "vom",
"by_day", "vom Tag",
"by_hour", "zur Stunde",
"bytes" , "bytes",
"chronological_order", "chronologische Sortierung", 
"coming_from", "kommt von",
"computed_with", "erstellt mit",
"connecting_to", "verbunden mit",
"connecting_to_the_server", "verbunden mit dem Server",
"countries", "L&auml;nder",
"daily" , "Tage",
"data_sent_for_dir" , "Gesendete Daten f&uuml;r das Verzeichnis",
"day" , "Tag",
"days", "Tage",
"description", "Beschreibung",
"different_images", "Unterschiedliche Grafiken",
"different_references_found", "Unterschiedliche Referenzen gefunden",
"directories" , "Verzeichnisse",
"directory" , "Verzeichnis",
"domain", "Dom&auml;ne",
"engine_keywords_used", "am meisten genutzte Suchbegriffe",
"exceeding", "&uuml;berschreitet",
"excluding", "ausgenommen",
"external" , "Extern",
"files_stored_locally_CD-ROM", "in diesen Links, falls sich Ihre Dateien auf einer CD-ROM befinden",
"for_today" , "f&uuml;r heute",
"from", "von",
"from_dom" , "von Dom&auml;ne", 
"from domain", "von Dom&auml;ne",
"from_outside", "von ausserhalb",
"global", "global",
"hTML_pages", "HTML Seiten",
"have", "haben",
"host", "Host",
"hosts", "Hosts",
"hour" , "Stunde", 
"hours" , "Stunden", 
"images", "Grafiken",
"images_found_on_server", "Gefundene Grafiken auf diesem Server",
"in", "in",
"in_this_directory", "in diesem Verzeichnis",
"in_whole_directory", "im gesamten Verzeichnis",
"internal", "intern",
"last_read_on", "zuletzt gelesen am",
"less_than", "kleiner als",
"links", "Links", 
"local", "Lokal",
"maximum", "maximum",
"minimum", "minimum",
"minutes", "Minuten",
"minute", "Minute",
"modified_less_than", "modifiziert fr&uuml;her als",
"monthly", "Monate",
"more_than" , "mehr als",
"most_common_errors" , "meiste &uuml;bliche Fehler",
"most_graphic_pages", "Seiten mit den meisten Grafiken",
"most_linky_pages", "Seiten mit den meisten Links",
"most_successful_hosts" , "meisten erfolgreichen Hosts",
"most_succf_browsers_vtime1" , "Auswertung der",
"most_succf_browsers_vtime2" , "meisten erfolgreichen Browser",
"most_succf_browsers1" , "Die",
"most_succf_browsers2" , "meist erfolgreich genutzten Browser",
"most_weighty_pages", "meisten grossen Seiten",
"no_reference_found", "keine Referenz gefunden",
"not_defined", "nicht definiert",
"not_included", "nicht beinhaltet",
"of_different_hosts" , "von verschiedenen Hosts",
"of_months" , "von Monaten",  
"on", "von",
"only_reading_time_below", "nur Lesezeit kleiner als",
"only_session_more_than", "nur Sessions mit weniger als",
"optdirsize1" , "(externe und Domain HTML Seiten)",
"optdirsize2" , "(externe HTML Seiten)",
"optdirsize3" , "(Dom&auml;nen HTML Seiten)",
"optdirsize4" , "(alle externen und Dom&auml;nenanfragen)",
"optdirsize5" , "(alle externen Anfragen)",
"optdirsize6" , "(alle Dom&auml;nenanfragen)",
"page", "Seite",
"pages" , "Seiten",
"pages_found_on_server", "gefundene Seiten auf dem Server",
"percentage" , "Prozente", 
"read_by", "gelesen von",
"referer_pages1" , "Referer Seiten",
"request" , "Anfrage", 
"requests" , "Anfragen", 
"resolved_countries", "erkannte L&auml;nder",
"scripts", "Skripte",
"search_engine", "Suchmaschine",
"seconds", "Sekunden",
"session", "Session",
"sessions", "Sessions",
"since", "seit",
"sites", "Gegenstellen",
"symbolic_links", "Symbolische Verkn&uuml;pfungen",
"text_only", "Nur Text",
"the", "die", 
"there_are", "es sind",
"times" , "Zeiten",
"to", "an",
"today", "heute",
"top" , "oben",
"top_external_sites" , "Externe Gegenstellen",
"top_local_sites" , "Lokale Gegenstellen",
"total" , "Total",
"total_data_sent_for" , "total Daten gesendet f&uuml;r",
"total_for" , "f&uuml;r",
"traffic_in" , "Transfer in",
"unknown", "unbekannt",
"unresolved", "unbekannte",
"used", "auf dem Server genutzt",
"used2", "auf dem Server genutzt",
"visitors", "Besucher",
"weekly", "Wochen",
"weight", "Gewichtung",
"weighting", "Gewichtung",
"will_be_printed", "werden ausgegeben",
"with_at_least", "mit mindestens",
"with_less_than", "mit mindestens",
"with_most_accesses", "mit den meisten Zugriffen",
"with_the_same_title", "mit dem gleichen Titel",
"without", "ohne",
"without_title", "ohne Titel",
"wrong", "falsch",
"Ascension", "Ascension",
"Andorra", "Andorra",
"United-Arab-Emirates", "Vereinigte Arabische Emirate", 
"Afghanistan", "Afghanistan",
"Anguilla", "Anguilla",
"Albania", "Albanien",
"Antigua-and-Barbuda", "Antigua und Barbuda",
"Armenia", "Armenien",
"Arpa", "Arpanet",
"Argentina", "Argentinien",
"Angola", "Angola",
"Antartica", "Antarktis",
"Austria", "&Ouml;sterreich",
"Australia", "Australien",
"Aruba", "Aruba",
"Azerbaijan", "Aserbeidschan",
"Bosnia-Herzegovina", "Bosnien Herzegovina",
"Bangladesh", "Bangladesh",
"Belgium", "Belgien",
"Burkina-Faso", "Burkina Faso",
"Bulgaria", "Bulgarien",
"Bahrain", "Bahrain",
"Bermuda", "Bermuda",
"Brunei-Darussalam", "Brunei Darussalam",
"Burundi", "Burundi",
"Benin", "Benin",
"Bolivia", "Bolivien",
"Brazil", "Brasilien",
"Bahamas", "Bahamas",
"Barbados", "Barbados",
"Botswana", "Botswana",
"Belarus", "Weissrussland",
"Belize", "Belize",
"Buthan", "Buthan",
"British-Indian-Ocean-Territory", "British Indian Ocean Territory",
"Christmas-Island", "Weihnatsinseln",
"Canada", "Kanada",
"Central-African-Rep", "Zentral Afrikanische Republik",
"Republic-of-Congo", "Republic of Congo",
"Democratic-Republic-of-the-Congo", "Democratic Republic of the Congo",
"Switzerland", "Schweiz",
"Ivory-Coast", "Elfenbeinkste",
"Chile", "Chile",
"Cameroon", "Kamrun",
"China", "China",
"Colombia", "Kolumbien",
"Cook-Islands", "Cook Islands",
"Commercial", "Commercial",
"Costa-Rica", "Costa Rica",
"Cuba", "Kuba",
"Cyprus", "Zypern",
"Czech-Republic", "Tschechische Republik",
"Germany", "Deutschland",
"Djibouti", "Djibouti",
"Denmark", "D&auml;nemark",
"Dominica", "Dominica",
"Dominican-Republic", "Dominikanische Republik",
"Algeria", "Algerien",
"Ecuador", "Ecuador",
"US-Educational", "US Bildungseinrichtungen",
"Estonia", "Estland",
"Egypt", "&Auml;gypten",
"Spain", "Spanien",
"Ethiopia", "&Auml;thipien",
"Finland", "Finnland",
"Fidji", "Fidji",
"Faroe-Islands", "Faroer Inseln",
"France", "Frankreich",
"Gabon", "Gabon",
"Great-Britain", "Grossbritannien",
"French-Guiana", "Franz&ouml;sisch Guiana",
"Georgia", "Georgien",
"Ghana", "Ghana",
"Gibraltar", "Gilbraltar",
"US-Government", "US Government",
"Guadeloupe", "Guadeloupe",
"Greece", "Griechenland",
"Greenland", "Gr&ouml;nland",
"Guinea", "Guinea",
"Guyana", "Guyana",
"Guatemala", "Guatemala",
"Guam", "Guam",
"Guinea-Bissau", "Guinea Bissau",
"Hong-Kong", "Hong-Kong", 
"Honduras", "Honduras",
"Croatia", "Kroatien",
"Hungary", "Ungarn",
"Indonesia", "Indonesien",
"Ireland", "Irland",
"Israel", "Israel",
"India", "Indien",
"International", "International",
"Iceland", "Island",
"Iran", "Iran",
"Italy", "Italien",
"Jamaica", "Jamaica",
"Japan", "Japan",
"Jordan", "Jordan",
"Cambodia", "Kambodscha",
"Comoros", "Comoros",
"South-Korea", "S&uuml;d Korea",
"Kenya", "Kenia",
"Kuwait", "Kuwait",
"Kazachstan", "Kazachstan",
"Kyrgyzstan", "Kyrgyzstan",
"Cayman-Islands", "Cayman Inseln",
"Lebanon", "Libanon",
"Saint-Tome-and-Principe", "Saint Tome and Principe",
"Sainte-Lucia", "Santa Lucia",
"Lesotho", "Lesotho",
"Liechtenstein", "Liechtenstein",
"Lithuania", "Lithuania",
"Latvia", "Lettland",
"Luxembourg", "Luxemburg",
"Sri-Lanka", "Sri Lanka",
"US-Military", "US Milit&auml;r",
"Madagascar", "Madagaskar",
"Macau", "Macau",
"Macedonia", "Mazedonien",
"Mexico", "Mexico",
"Malaysia", "Malaysia",
"Micronesia", "Micronesia",
"Morocco", "Marocco",
"Moldova", "Moldova",
"Monaco", "Monaco",
"Maldives", "Malediven",
"Martinique", "Martinique (Frankreich)",
"Malta", "Malta",
"Mauritius", "Mauritius",
"Mauritania", "Mauritania",
"Mozambique", "Mozambique",
"Namibia", "Namibia",
"NATO", "NATO",
"New-Caledonia", "New Caledonia", 
"Network", "Netzwerk",
"Nicaragua", "Nikaragua",
"Netherlands", "Niederlande",
"Norway", "Norwegen",
"Nepal", "Nepal",
"New-Zealand", "Neuseeland",
"Niue", "Niue",
"Niger", "Niger",
"Nigeria", "Nigeria",
"Non-Profit", "Organisationen",
"Oman", "Oman",
"Panama", "Panama",
"Puerto-Rico", "Puerto Rico",
"French-Polynesia", "Franz&ouml;isch Polynesia",
"Pakistan", "Pakistan",
"Paraguay", "Paraguay",
"Peru", "Peru",
"Papua-New-Guinea", "Papua - Neu Guinea",
"Philippines", "Philippinen",
"Poland", "Polen",
"Portugal", "Portugal",
"Qatar", "Qatar",
"Romania", "Rum&auml;nien",
"Russian-Federation", "Russische F&ouml;deration",
"Saudi-Arabia", "Saudi Arabien",
"San-Marino", "San Marino",
"Senegal", "Senegal",
"Sierra-Leone", "Sierra Leone",
"Sweden", "Schweden",
"Singapore", "Singapur",
"Slovenia", "Slovenien",
"Slovakia", "Slovakei",
"Swaziland", "Swaziland",
"Soviet-Union", "Sowjetunion",
"El-Savaldor", "El Salvador",
"Chad", "Chad",
"Tanzania", "Tanzania",
"Togo", "Togo",
"Thailand", "Thailand",
"Tonga", "Tonga",
"Turkey", "T&uuml;rkei",
"Taiwan", "Taiwan",
"Trinidad-and-Tobago", "Trinidad and Tobago",
"Turkmenistan", "Turkmenistan",
"Tunisia", "Tunesien",
"Ukraine", "Ukraine",
"Uganda", "Uganda",
"United-Kingdom", "Vereinigtes K&ouml;nigreich",
"United-States", "Vereinigte Staaten",
"Uruguay", "Uruguai",
"Uzbekistan", "Uzbekistan",
"Vatican", "Vatikan",
"Venezuela", "Venezuela",
"Vietnam", "Vietnam",
"Virgin-Islands-USA", "Jungfrauen Inseln (USA)",
"Virgin-Islands-UK", "Jungfrauen Inseln (British)",
"South-Africa", "S&uuml;d Afrika",
"Yemen", "Jemen",
"Yugoslavia", "Jugoslawien",
"Zambia", "Zambia",
"Zimbabwe", "Zimbabwe",
"Netherlands-Antilles", "Niederl&auml;ndische Antillen",
"American-Samoa", "American Samoa",
"Mongolia", "Mongolia",
"Norfolk-Island", "Norfolk Island",
"Iraq", "Irak",
"Vanuatu", "Vanuatu",
"Mali", "Mali",
"Rwanda", "Ruanda",
"Heard-and-McDonald-Islands", "Heard and McDonald Inseln",
"Solomon-Islands", "Solomon Inseln",
"Cocos-Islands", "Cocos Inseln",
"Samoa", "Samoa",
"Mayotte", "Mayotte",
"Turks-and-Caicos-Islands","Turks und Caicos Inseln",
"Saint-Pierre-et-Miquelon","Saint Pierre und Miquelon",
"Sierra-Leone", "Sierra Leone",
"South-Georgia-and-South-Sandwich-Islands","South Georgia und South Sandwich Inseln",
"Jersey-Channel-Islands", "Jersey (Channel Inseln)",
"Eritrea", "Eritrea",
"Tuvalu", "Tuvalu",
"Isle-of-Man", "Isle of Man",
"Laos", "Laos",
"Suriname", "Suriname",
"Montserrat", "Montserrat",
"Seychelles", "Seychelles",
"Grenada", "Grenada",
"Guernsey-Channel-Islands", "Guernsey (Channel Islands)",
"Saint-Helena", "Saint Helena",
"Papua-New-Guinea", "Papua New Guinea",
"Business", "Business",
"Cooperative", "Cooperative",
"Professional", "Professional",
"Name", "Name",
"Aeronautic", "Aeronautic",
"Info", "Info",
"Museum", "Museum",
"US-Minor-Outlying-Islands", "US Minor Outlying Islands",
"European-Union", "European Union",
"Saint-Kitts-Nevis-Anguilla", "Saint Kitts &amp; Nevis - Anguilla",
"Cape-Verde", "Cape Verde",
"Syria", "Syria",
"Haiti", "Haiti",
"Liberia", "Liberia",
"Libya", "Libya",
"North-Korea", "North Korea",
"Sudan", "Sudan",
"Palestine", "Palestine",
"Tadjikistan", "Tadjikistan",
"Saint-Vincent-Grenadines", "Saint Vincent &amp; Grenadines",
"Gambia", "Gambia",
"Equatorial-Guinea", "Equatorial Guinea",
"Kiribati", "Kiribati",
"Tokelau", "Tokelau",
"Local", "Local Network",
"Satellite", "Satellite",
"Falkland-Islands", "Falkland Islands",
"Myanmar", "Myanmar",
"Northern-Mariana-Islands", "Northern Mariana Islands",
"Malawi", "Malawi",
"Former-Czechoslovakia", "Former Czechoslovakia",
"Unknown", "Unbekannt"
 );
