#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                  CRONTAB CONFIGURATION FILES                   #####
####                                                                #####
####                    (http server)                               #####
####                                                                #####
####    domisse@w3perl.com                   version 16/04/2002     #####
####                                                                #####
#########################################################################

require "/var/www/cgi-bin/w3perl/init.pl";

# Print out a content-type for HTTP/1.0 compatibility
print "Content-type: text/html\n\n";

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);

    # Un-Webify plus signs and %-encoding
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    # Stop people from using subshells to execute commands
    # Not a big deal when using sendmail, but very important
    # when using UCB mail (aka mailx).
    # $value =~ s/~!/ ~!/g; 

    # Uncomment for debugging purposes
#    print "Setting $name to $value<P>";
	
    $FORM{$name} = $value;
}

$cronw3perl = "cron-w3perl".$plext;
$fileconf = $FORM{'configfile'};
$fileconf =~ s/$plext//;
$pos = rindex($fileconf,$dirsep);
$fileconf = substr($fileconf,$pos,length($fileconf));
$loadconf = $w3perlpathres.$fileconf;
&load($loadconf);
#&loadvar($varforms);

#########################################################################
###                            LAUNCH                                 ###
#########################################################################

if ($ENV{'QUERY_STRING'} =~ /display/) {

#$hiddentag = "<INPUT NAME=\"script\" TYPE=\"hidden\" VALUE=\"$FORM{'script'}\"><BR>\n";
#$hiddentag .= "<INPUT NAME=\"configfile\" TYPE=\"hidden\" VALUE=\"$FORM{'configfile'}\"><BR>\n";
#$hiddentag .= "<INPUT NAME=\"version\" TYPE=\"hidden\" VALUE=\"1\">";

$filename = $pathsetup."crontab".$htmlext;

# MAJ de $loadconf et de $w3perlpath$dirsep$dirconfig$dirsep$FORM{'configfile'}$plext !

$FORM{'inc_launch_time'} += 12 if ($FORM{'scripthourap'} == 12);

# Rewrite de $loadconf

open(FILE,"$loadconf");
@lines = (<FILE>);
close FILE;

open(FILE,">$loadconf") || die "Can't open $loadconf";
foreach $line (@lines) {
    ($val1,$val2) = split(/\s+/,$line);
    if ($val1 =~ /actif/i) {
	$line =~ s/$val2/$FORM{$val1}/ if ($FORM{$val1} == 1);
	$line =~ s/$val2/0/ if ($FORM{$val1} != 1);
	}
    if ($val1 =~ /launch/i) {
	$line =~ s/$val2/$FORM{$val1}/ if ($FORM{$val1} ne '');
    }

    print FILE "$line";
}
close(FILE);

# Rewrite de $w3perlpath$dirconfig$dirsep$FORM{'configfile'}$plext

$pos = rindex($FORM{'configfile'},$dirsep);
$prefile = substr($FORM{'configfile'},0,$pos+1);
#$FORM{'configfile'} = substr($FORM{'configfile'},$pos+1,length($FORM{'configfile'}));

$filetmp = "$w3perlpath$dirconfig$fileconf$plext ";

#$line2 = $filetmp;

$FORM{'hour_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'day_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'week_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'month_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'agent_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'refer_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'error_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'session_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'url_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'history_launch_time'} = $FORM{'inc_launch_time'};

open(FILE,"$filetmp");
@lines = (<FILE>);
close FILE;

open(FILE,">$filetmp") || die "Can't open $filetmp";
foreach $line (@lines) {
    chop($line);
    if ($line =~ /actif/) {
	($val1,$val2) = split(/\s+=\s+/,$line);
	$val2 =~ s/;//;
	$val1 =~ s/\$//;
	$line =~ s/$val2/$FORM{$val1}/ if ($FORM{$val1} == 1);
	$line =~ s/$val2/0/ if ($FORM{$val1} != 1);	
    }
    if ($line =~ /launch/i) {
	($val1,$val2) = split(/\s+=\s+/,$line);
	$val2 =~ s/;//;
	$val1 =~ s/\$//;
	$line =~ s/$val2/$FORM{$val1}/ if ($FORM{$val1} ne '');
    }
    print FILE "$line\n";
}
close(FILE);

#

$comment = "Your configuration file $filetmp have been updated. You should now COPY it in $FORM{'configfile'}. (I can't do the copy for security restriction)";

&error_open($filename) if (!(-r $filename));
open(FILE,"$filename") || die "Can't open $filename\n";
while (<FILE>) {
#    s/<!-- HELP -->/$helpurl/;
    s/<!-- BG -->/$bkg/;
    s/<!-- LINE -->/$bkgline/;
    s/<!-- bkglink -->/$bkglink/;
    s/<!-- bkgback -->/$bkgback/;
#    s/<!-- HIDDEN -->/$line2/;
#    s/<!-- configfile -->/$FORM{'configfile'}/;
#    s/<!-- cgiurl -->/$cgiurl/;
#    s/<!-- w3perlurl -->/$w3perlurl/;
#    s/<!-- hidden -->/<!-- hidden -->\n$hiddentag/;
    s/<!-- COMMENT -->/$comment/;
    s/<!-- DISPLAY -->/$FORM{'inc_launch_time_min'} $FORM{'inc_launch_time'} * * * $prefile$cronw3perl -e/;
    print;

#print "$tmp1 - $oldvalue{$tmp1}\n";
}
close (FILE);



exit;
}

#########################################################################
###                            DISPLAY                                ###
#########################################################################

# Get the input

$filename = $pathsetup."cron".$htmlext; 

$file = $FORM{'configfile'}; 

$hidden = "<INPUT NAME=configfile TYPE=hidden VALUE=\"$file\">";

# ouvrir le fichier de config et regarder quels sont les scripts actifs...

#&load($loadconf);

$temps = $oldvalue{'inc_launch_time'}*60+$oldvalue{'inc_launch_time_min'};
$oldvalue{'inc_launch_time'} -= 12 if ($oldvalue{'inc_launch_time'} > 11);
$oldvalue{'scripthourap'} = 0 if ($temps <= 720);
$oldvalue{'scripthourap'} = 12 if ($temps > 720);

open(FILE,$filename);
while (<FILE>) {
    $out = 0;
    s/<!-- HELP -->/$helpurl/;
    s/<!-- BG -->/$bkg/;
    s/<!-- LINE -->/$bkgline/;
    s/<!-- WARNING -->/$string_err/;
    s/<!-- DISPLAY -->/$string/;
    s/<!-- HIDDEN -->/$hidden/;
    $line = $_;

    if ($line =~ /(NAME=")([\w]+)".*("radio").*(VALUE=")([0-9a-zA-Z_]+)(")/i) {
	print "$`$1$2\" TYPE=$3 $4$5$6 CHECKED$'" if ($5 eq $oldvalue{$2});
	print "$`$1$2\" TYPE=$3 $4$5$6$'" if ($5 ne $oldvalue{$2});
	$out = 1;
    }

	if ($line =~ /(NAME=")([\w]+)".*("checkbox").*(VALUE=")([0-9a-zA-Z_]+)(")/i) {
	    print "$`$1$2\" TYPE=$3 $4$5$6 CHECKED$'" if ($5 eq $oldvalue{$2});
	    print "$`$1$2\" TYPE=$3 $4$5$6$'" if ($5 ne $oldvalue{$2});
	    $out = 1;
	}

	if ($line =~ /<SELECT NAME="([0-9a-zA-Z_]+)"/ && $line !~ /HIDDEN/i) {
	    $val = $1;
	}

	if ($line =~ /OPTION VALUE="([0-9a-zA-Z_]+)">/i) {
	    print "$`OPTION VALUE=\"$1\" SELECTED>$'" if ($1 eq $oldvalue{$val});
	    print "$`OPTION VALUE=\"$1\">$'" if ($1 ne $oldvalue{$val});
	    $out = 1;
    }



	print "$line" if ($out == 0);
}
close (FILE);
