#!/usr/local/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                    Language Script                             #####
####                     (http server)                              #####
####                                                                #####
####    domisse@w3perl.com                   version 02/05/2003     #####
####                                                                #####
#########################################################################

# Look for YYY string for new or updated strings

%LangNL = (
"Cached_files", "Cached files",
"Cached_trafic", "Cached trafic",
"Downloaded_files", "Downloaded files",
"Downloaded_trafic", "Downloaded trafic",
"milliseconds", "ms",
"Stats_over", "Stats over",
"updated_every", "updated every",
"with_an_integration_time_of", "with an integration time of",
"Real_time","Real time",
"Abort","Abort",
"Status_code","Status code",
"Size","Size",
"Download_not_completed","Download not completed",
"Outgoing_traffic", "Outgoing traffic",
"Incoming_traffic", "Incoming traffic",
"Virus", "Virus",
"virus", "virus",
"internal_pages", "interne pagina's",
"Internal_pages", "Interne pagina's",
"Accesses_only", "Alleen toegang",
"accesses", "toegang",
"First_line_is_number_of_files_according_to_seuil", "De eerste regel is het aantal bestanden aan de hand van de
gekozen limiet",
"Second_line_is_number_of_accesses_according_to_seuil", "De tweede regel is het aantal keer toegang aan de hand
van de gekozen limiet", 
"percentage_relative_to_number_without_seuil", "percentage relatief aan het aantal zonder gekozen limiet",
"Gb", "Gb",
"Tb", "Tb",
"most_successful_bookmark", "meest succesvolle bookmark",
"Bookmarked_page", "Bookmarked pagina",
"Difference", "Verschil",
"Minimum", "Minimum",
"Maximum", "Maximum",
"Only_files", "Alleen bestanden",
"Filetype", "Bestandstype",
"28800_modem", "28800 modem",
"A_description", "Een beschrijving",
"About_months", "Tabel over maanden", 
"About_weeks", "Tabel over weken", 
"Absolute_links", "Absolute links",
"Acces_not_taken_into_account", "Gegevens uitgesloten van verwerking",
"Accesses", "Toegang", 
"All_html_pages_requests", "Alle html pagina aanvragen",
"All_images_requests", "Alle afbeelding aanvragen",
"All_requests", "Alle aanvragen",
"All_sites", "Alle servers",
"At", "op",
"Average_CPU", "Gemiddelde CPU tijd",
"Average", "Gemiddeld",
"Average_is_black", "Gemiddelde in zwart",
"Average_on_hours_and_days", "Gemiddelde over uren en dagen",
"Average_pages_by_session", "Gemiddeld aantal pagina's gelezen per sessie",
"Average_session_time", "Gemiddelde tijd voor een sessie",
"Average_reading_time_per_page", "Gemiddelde leestijd per pagina",
"Back", "Terug",
"Background", "Achtergrond",
"Bad_links", "Slechte links",
"Blue_line_is_average", "De blauwe lijn is het gemiddelde",
"Browser", "Browser",
"Browsers", "Browsers",
"Browsers_used", "Browser gebruik",
"CPU", "CPU tijd",
"Cgi-bin", "Cgi-bin",
"Conn_Mach", "verbonden machines", 
"Connection_time", "Verbindingstijd",
"Correct_size_taken_from_image", "Correcte grootte genomen van afbeelding",
"Countries", "Landen", "countries", "landen",
"Data", "Data",
"Data_traffic_by_weeks", "Data verkeer per week",
"Data_unit_Kb", "Kilobytes",
"Data_unit_Mb", "Megabytes",
"Data_unit_octet", "bytes",
"Date", "Datum", 
"Days", "Dagen",
"Decrease_over_the_previous_day","Afname over de voorgaande dag",
"Directories", "Directories",
"Directories_graphs", "Directory grafieken",
"Docs", "Docs",
"Documents", "Documenten",
"DomReq", "Domein aanvragen", 
"Domain", "Domein",
"Domain_Hosts", "Domein servers",
"Download", "Download",
"Downloading_time", "Download tijd",
"Error", "Fout",
"Errors", "Fouten",
"Evolution_of", "Ontwikkeling van",
"File", "Bestand",
"Forbidden", "Verboden",
"Found_in", "Gevonden in",
"Frames", "Frames",
"Frames_excluding", "Frames met uitzondering van",
"Global_access", "Algemene gegevens",
"Graphic", "Grafisch",
"Graphs_for", "Grafieken voor",
"Graphs_for_dir", "Grafieken voor directory",
"HTML_files", "HTML bestanden",
"Histogram_about_average_request", "Histogram over het gemiddeld aantal aanvragen",
"Histogram_sessions", "Histogram van sessies",
"Hosts", "Hosts",
"Hosts_excluding", "Uitgesloten hosts",
"Hosts_from", "Hosts van",
"Hour", "Uur", 
"Hours", "Uren", 
"Image", "Afbeelding", 
"Images", "Afbeeldingen", 
"Images_histogram", "Afbeeldingen Histogram",
"Images_never_used", "Ongebruikte afbeeldingen",
"Increase_over_the_previous_day", "Toename over de voorgaande dag",
"Index", "Inhoud",
"Index_pages", "Inhoudspagina's",
"Inside", "Intern",
"Kb", "Kb", 
"Kbytes", "Kilobytes", 
"Keywords", "Sleutelwoorden",
"Language", "Nederlands",
"Last_occurence", "Laatste keer",
"Last_try", "Laatste poging",
"Legend_in_bracket", "Legenda tussen haakjes",
"Lines_processed", "Regels verwerkt",
"Level", "Niveau",
"Link", "Link",
"Links", "Links",
"Links_histogram", "Links histogram",
"ListOf", "Lijst van",
"ListOfSites", "Lijst van sites",
"List_of", "Lijst van",
"List_of_unresolved_hosts", "Onbekende",
"Login", "Login",
"Longest_external_session", "Langste externe sessie",
"Longest_local_session", "Langste lokale sessie",
"Longest_session", "Langste sessie",
"Mach_Dom", "machines van domein", 
"Mb", "Mb",
"Mbytes", "Megabytes",
"Method", "Methode",
"Mhosts", "servers", 
"Misc", "Diversen",
"MonthByMonth", "Maand voor maand", 
"Month_of", "Maand ", 
"Month", "Maand", 
"Months", "Maanden", 
"More_Precise", "nauwkeuriger",
"MostSuccesf", "de meest succesvolle",
"Multiple_sessions", "Meervoudige sessies",
"New_country", "Nieuwe landen",
"New_HTML_files", "Nieuwe HTML bestanden",
"New_Hosts", "Nieuwe servers", 
"New_Mach", "nieuwe machines", 
"Newest_pages", "Nieuwste pagina's",
"Newest_pages_histogram", "Nieuwste pagina's histogram",
"News", "Nieuws",
"NoReq", "Aantal aanvragen",
"No_Ttl_Req_Mnth", "Totaal aantal aanvragen per maand",
"No_Ttl_Req_Week", "Totaal aantal aanvragen per week",
"No_login", "Geen login aanvragen",
"No_modification", "Geen aanpassing",
"No_request", "Er zijn geen aanvragen geweest",
"No_robot_session", "Geen robot sessie gevonden",
"No_title", "Geen titel",
"Not_found", "Niet gevonden",
"Number", "Aantal",
"Number_of", "Aantal", 
"Number_of_HTML_files", "Aantal HTML bestanden",
"Number_of_different_resolved_countries", "Aantal verschillende landen",
"Number_of_different_pages_used", "Aantal verschillende pagina's gebruikt",
"Number_of_different_sites", "Aantal verschillende sites",
"Number_of_pages_read", "Aantal pagina's gelezen",
"Number_of_req_by_weeks", "Aantal aanvragen per week",
"Number_of_requests", "Aantal aanvragen",
"Number_of_visits", "Aantal bezoeken",
"OS", "OS",
"OS_used1", "De",
"OS_used2", "gebruikte operating systems",
"Occurence", "Frequentie",
"On", "Op", 
"Only_HTML_files_itself", "Alleen gewicht HTML bestanden zelf",
"Only_directories", "Alleen directories",
"Only_first", "Alleen de eerste",
"Only_hosts", "Alleen servers",
"Only_pages", "Alleen pagina's",
"Only_scripts", "Alleen scripts",
"Only_time_session_upper", "Alleen tijdsessies langer dan",
"Others", "Anderen",
"Outside", "Extern",
"Page", "Pagina",
"Pages_excluding", "Uitgesloten pagina's", 
"Page_read", "Pagina's gelezen",
"Page_reading_time_histogram", "Histogram van leestijd HTML pagina's",
"Pages", "Pagina's",
"Pages_never_used", "Ongebruikte pagina's",
"Percentage", "Percentage",
"Proxy", "Proxy",
"Reading_time", "Leestijd",
"Reading_time_sessions", "Sessies met leestijd",
"Redirect", "Redirect",
"References_for", "Verwijzigingen naar",
"Referer", "Verwijzingen",
"Referer_about", "Verwijzingen voor",
"Referer_on", "Pagina's die verwijzen naar pagina",
"Referer_pages2", "Verwijzende pagina's",
"Request", "Aanvraag", 
"Requests", "Aanvragen", 
"Robot_name", "Robot naam",
"Robots_excluding", "Robots met uitzondering van",
"Robot_session_exclude", "Robot sessies zijn uitgesloten",
"Same_over_the_previous_day", "Gelijk aan de voorgaande dag",
"Same_title", "Dezelfde titel",
"Scripts", "Scripts",
"Search_engine", "Zoeksysteem",
"Send_me_an", "Zend mij een",
"Server_tree", "Server tree",
"Session", "Sessie",
"Session_cut1", "als een sessie langer is dan een dag, dan wordt deze in de eerste dag geteld",
"Session_cut2", "Onnauwkeurigheid kan voorkomen als sommige sessies overlopen naar de volgende dag",
"Session_time", "Sessie tijd",
"Session_title", "Sessie tijd",
"Sessions", "Sessies",
"Sessions_from", "Sessies van",
"Sorted_countries_list", "Gesorteerde landenlijst",
"Sorted_virtual_server_list", "Gesorteerde virtuele server lijst",
"Speed", "Snelheid",
"Stats_about_CPU", "Statistieken over de CPU tijd",
"Stats", "Statistieken", 
"Stats_aboutMnth", "Statistieken over de maand ",
"Stats_about_HTML_files", "Statistieken over HTML bestanden",
"Stats_about_HTML_files_weight", "Statistieken over gewicht HTML bestanden",
"Stats_about_alt", "Stats over ALT",
"Stats_about_errors", "Statistieken over fouten", 
"Stats_about_host", "Statistieken over server", 
"Stats_about_hosts", "Statistieken over servers",
"Stats_about_images", "Statistieken over afbeeldingen",
"Stats_about_internal_links", "Statistieken over interne links",
"Stats_about_login", "Statistieken over login",
"Stats_about_months", "Statistieken over maanden", 
"Stats_about_robots_sessions", "Statistieken over robot sessies",
"Stats_about_session_length", "Statistieken over  sessie lengte",
"Stats_about_sessions", "Statistieken over sessies",
"Stats_about_visits", "Statistieken over bezoekers",
"Stats_about_virtual_servers", "Statistieken over virtuele servers",
"Stats_about_weeks", "Statistieken over weken", 
"Stats_about_width", "Statieken over WIDTH en HEIGHT",
"Stats_aboutlastdays1", "Statistieken over de laatste",
"Stats_aboutlastdays2", "dagen",
"String", "Zoeksleutel",
"Successful_pages", "Successvolle pagina's",
"Summary", "Samenvatting",
"Symbolic_links", "Symbolic links",
"Tab_about_lastdays1", "Tabel over de laatste",
"Tab_about_lastdays2", "dagen",
"Table", "Tabel", 
"Text", "Tekst",
"Textual_version", "Tekst versie",
"The_Top", "The Top",
"Time", "Tijd",
"Total", "Totaal",
"Total_HTML_access", "Totaal aantal HTML aanvragen",
"Total_data_sent", "Totale data verzonden",
"Total_number_of_directories", "Totaal aantal directories",
"Total_number_of_html_files", "Totaal aantal HTML bestanden",
"Total_number_of_images", "Totaal aantal afbeeldingen",
"Total_number_of_images_in_files", "Totaal aantal afbeeldingen in HTML bestanden",
"Total_number_of_links", "Totaal aantal links",
"Total_number_of_requests", "Totaal aantal aanvragen",
"Total_number_of_robot_session", "Totaal aantal robot sessies",
"Total_number_of_scripts", "Totaal aantal scripts",
"Total_number_sessions", "Totaal aantal sessies",
"Total_traffic", "Totaal verkeer",
"Traffic", "Verkeer", 
"Traffic_about", "Verkeer over",
"Traffic_statistics", "Verkeers statistieken",
"Tree", "Tree",
"Useless_pages", "Onbruikbare pagina's",
"Users", "Gebruikers",
"Virtual_servers", "Virtuele servers",
"You_should_add", "U dient",
"Web_size", "Web grootte",
"Week", "Week", 
"Weeks", "Weken", 
"Weight_HTML_files_histogram", "histogram gewicht HTML bestanden",
"Weight_of_HTML_files", "gewicht HTML bestanden",
"With", "met", 
"about", "over", 
"about_hours_and_days", "over uren en dagen",
"absolute_links", "absolute links",
"added_pages", "als u een van uw pagina's hier wenst toe te voegen",
"all_sites", "alle sites",
"among", "van de", 
"and", "en",
"are_printed", "worden afgedrukt",
"average_HTML_accesses", "gemiddeld aantal HTML aanvragen",
"bad_links", "slechte links",
"by", "per",
"by_day", "per dag",
"by_hour", "per uur",
"bytes", "bytes", 
"chronological_order", "chronologische volgorde",
"coming_from", "komend van",
"computed_with", "berekend met",
"connecting_to", "verbindend met",
"connecting_to_the_server", "verbindend met de server",
"countries", "landen",
"daily", "dagen",
"data_sent_for_dir", "verkeer voor de directory",
"day", "dag", 
"days", "dagen",
"description", "omschrijving",
"different_images", "verschillende afbeeldingen",
"different_references_found", "verschillende verwijzingen",
"directories", "directories",
"directory", "directory",
"domain", "domein",
"engine_keywords_used", "sleutelwoorden die gebruikt zijn",
"engine_search" , "Zoekmachine",
"exceeding", "overschrijdend",
"excluding", "zonder",
"external", "extern",
"files_stored_locally_CD-ROM", "toe te voegen aan deze links als uw bestanden lokaal of op CD-ROM zijn
opgeslagen",
"for_today", "voor vandaag",
"from domain", "van domein",
"from", "van",
"from_dom", "van domein", 
"from_outside", "van buiten",
"global", "globaal",
"hTML_pages", "HTML pagina's",
"have", "hebben",
"host", "server",
"hosts", "servers",
"hour", "uur", 
"hours", "uren", 
"images", "afbeeldingen",
"images_found_on_server", "afbeeldingen gevonden op de server",
"in", "in",
"in_this_directory", "in deze directory",
"in_whole_directory", "in de gehele directory",
"internal", "intern",
"last_read_on", "laatst gelezen op", 
"less_than", "kleiner dan",
"links", "links", 
"local", "lokaal",
"maximum", "maximum",
"minimum", "minimum",
"minutes", "minuten",
"minute", "minuten",
"modified_less_than", "gewijzigd minder dan",
"monthly", "maanden",
"more_than", "met meer dan",
"most_common_errors", "meest voorkomende fouten",
"most_graphic_pages", "meest grafische pagina's",
"most_linky_pages", "pagina's met de meeste links",
"most_successful_hosts", "meest succesvolle servers",
"most_succf_browsers1", "De",
"most_succf_browsers2", "meest successvolle browsers",
"most_succf_browsers_vtime1", "De",
"most_succf_browsers_vtime2", "meest successvolle browsers versus tijd",
"most_weighty_pages", "zwaarste pagina's",
"no_reference_found", "geen verwijzing gevonden",
"not_defined", "niet gedefinieerd",
"not_included", "niet inbegrepen",
"of_different_hosts", "van verschillende servers", 
"of_months", "over maanden", 
"on", "op",
"only_reading_time_below", "alleen leestijden kleiner dan",
"only_session_more_than", "alleen sessies met meer dan",
"optdirsize1", "(externe en domein HTML pagina's)",
"optdirsize2", "(externe HTML pagina's)",
"optdirsize3", "(domein HTML pagina's)",
"optdirsize4", "(alle externe and domein aanvragen)",
"optdirsize5", "(alle externe aanvragen)",
"optdirsize6", "(alle domein aanvragen)",
"page", "pagina",
"pages", "pagina's",
"pages_found_on_server", "pagina's gevonden op de server",
"percentage", "percentage",
"read_by", "gelezen door",
"referer_pages1", "verwijzende pagina's",
"request", "aanvraag", 
"requests", "aanvragen", 
"resolved_countries", "gevonden landen",
"scripts", "scripts",
"search_engine", "zoeksysteem",
"seconds", "seconden",
"entry_pages" , "begin pagina's",
"exit_pages" , "eind pagina's",
"Entry_pages" , "Begin pagina's",
"Exit_pages" , "Eind pagina's",
"session", "sessie",
"sessions", "sessies",
"since", "sinds",
"sites", "sites",
"symbolic_links", "symbolic links",
"text_only", "alleen tekst",
"the", "de",  
"there_are", "zijn er",
"times", "keer",
"to", "tot",
"today", "vandaag",
"top", "top",
"top_external_sites", "externe sites",
"top_local_sites", "lokale sites",
"total", "totaal",
"total_data_sent_for", "totaal verkeer voor",
"total_for", "van",
"traffic_in", "verkeer in",
"unknown", "onbekend",
"unresolved", "onbekend",
"used", "gebruikt op de server",
"used2", "gebruikt op de server",
"visitors", "bezoekers",
"weekly", "weken",
"weight", "gewicht",
"weighting", "wegend",
"will_be_printed", "zullen afgedrukt worden",
"with_at_least", "met tenminste",
"with_less_than", "met minder dan",
"with_most_accesses", "met de meeste aanvragen",
"with_the_same_title", "met dezelfde titel",
"without", "zonder",
"without_title", "zonder titel",
"wrong", "fout",
"Ascension", "Ascension",
"Andorra", "Andorra",
"United-Arab-Emirates", "Verenigde Arabische Emiraten", 
"Afghanistan", "Afghanistan",
"Anguilla", "Anguilla",
"Albania", "Albani&euml;",
"Antigua-and-Barbuda", "Antigua en Barbuda",
"Armenia", "Armeni&euml;",
"Arpa", "Arpanet",
"Argentina", "Argentini&euml;",
"Angola", "Angola",
"Antartica", "Antartica",
"Austria", "Oostenrijk",
"Australia", "Australi&euml;",
"Aruba", "Aruba",
"Azerbaijan", "Azerbaijan",
"Bosnia-Herzegovina", "Bosnia Herzegovina",
"Bangladesh", "Bangladesh",
"Barbados", "Barbados",
"Belgium", "Belgi&euml;",
"Burkina-Faso", "Burkina Faso",
"Bulgaria", "Bulgarije",
"Bahrain", "Bahrain",
"Bermuda", "Bermuda",
"Brunei-Darussalam", "Brunei Darussalam",
"Burundi", "Burundi",
"Benin", "Benin",
"Bolivia", "Bolivia",
"Brazil", "Brazili&euml;",
"Bahamas", "Bahamas",
"Botswana", "Botswana",
"Belarus", "Belarus",
"Belize", "Belize",
"Christmas-Island", "Christmas Island",
"Buthan", "Buthan",
"British-Indian-Ocean-Territory", "British Indian Ocean Territory",
"Canada", "Canada",
"Central-African-Rep", "Central African Republiek",
"Republic-of-Congo", "Republiek Congo",
"Democratic-Republic-of-the-Congo", "Democratische Republiek Congo",
"Switzerland", "Zwitserland",
"Ivory-Coast", "Ivoorkust",
"Chile", "Chili",
"Cameroon", "Cameroon",
"China", "China",
"Colombia", "Colombia",
"Cook-Islands", "Cook Islands",
"Commercial", "Commercial",
"Costa-Rica", "Costa Rica",
"Cuba", "Cuba",
"Cyprus", "Cyprus",
"Czech-Republic", "Czech Republic",
"Germany", "Duitsland",
"Djibouti", "Djibouti",
"Denmark", "Denemarken",
"Dominica", "Dominica",
"Dominican-Republic", "Dominicaanse Republiek",
"Algeria", "Algerije",
"Ecuador", "Ecuator",
"US-Educational", "US Educational",
"Estonia", "Estonia",
"Egypt", "Egypte",
"Spain", "Spanje",
"Ethiopia", "Ethiopi&euml;",
"Finland", "Finland",
"Fidji", "Fidji",
"Faroe-Islands", "Faroe Eilanden",
"France", "Frankrijk",
"Gabon", "Gabon",
"Great-Britain", "Groot Britanni&euml;",
"French-Guiana", "French Guiana",
"Georgia", "Georgia",
"Ghana", "Ghana",
"Gibraltar", "Gilbraltar",
"US-Government", "US Government",
"Guadeloupe", "Guadeloupe",
"Greece", "Griekenland",
"Greenland", "Greenland",
"Guinea", "Guinea",
"Guatemala", "Guatemala",
"Guam", "Guam",
"Guinea-Bissau", "Guinea Bissau",
"Guyana", "Guyana",
"Hong-Kong", "Hong Kong", 
"Honduras", "Honduras",
"Croatia", "Croati&euml;",
"Hungary", "Hungarije",
"Indonesia", "Indonesi&euml;",
"Ireland", "Ierland",
"Israel", "Isra&euml;l",
"India", "India",
"International", "Internationaal",
"Iceland", "IJsland",
"Iran", "Iran",
"Italy", "Itali&euml;",
"Jamaica", "Jamaica",
"Japan", "Japan",
"Jordan", "Jordani&euml;",
"Cambodia", "Cambodja",
"Comoros", "Comoros",
"South-Korea", "Zuid Korea",
"Kuwait", "Kuweit",
"Kazachstan", "Kazachstan",
"Kyrgyzstan", "Kyrgyzstan",
"Cayman-Islands", "Cayman Eilanden",
"Lebanon", "Libanon",
"Saint-Tome-and-Principe", "Saint Tome and Principe",
"Sainte-Lucia", "Sainte Lucia",
"Lesotho", "Lesotho",
"Liechtenstein", "Liechtenstein",
"Lithuania", "Lithuania",
"Latvia", "Latvia",
"Luxembourg", "Luxemburg",
"Sri-Lanka", "Sri Lanka",
"US-Military", "US Military",
"Madagascar", "Madagascar",
"Macau", "Macau",
"Macedonia", "Macedoni&euml;",
"Mexico", "Mexico",
"Malaysia", "Maleisi&euml;",
"Morocco", "Morokko",
"Moldova", "Moldova",
"Micronesia", "Micronesi&euml;",
"Monaco", "Monaco",
"Maldives", "Maldiven",
"Martinique", "Martinique (Frans)",
"Malta", "Malta",
"Mauritania", "Mauritani&euml;",
"Mauritius", "Mauritius",
"Mozambique", "Mozambique",
"Namibia", "Namibi&euml;",
"NATO", "NAVO",
"New-Caledonia", "Nieuw Caledoni&euml;", 
"Network", "Network",
"Nicaragua", "Nicaragua",
"Netherlands", "Nederland",
"Norway", "Noorwegen",
"Nepal", "Nepal",
"New-Zealand", "Nieuw Zeeland",
"Niue", "Niue",
"Niger", "Niger",
"Nigeria", "Nigeria",
"Non-Profit", "Organisaties",
"Oman", "Oman",
"Panama", "Panama",
"Puerto-Rico", "Puerto Rico",
"French-Polynesia", "French Polynesi&euml;",
"Papua-New-Guinea", "Papua - New Guinea",
"Pakistan", "Pakistan",
"Paraguay", "Paraguay",
"Peru", "Peru",
"Philippines", "Philippijnen",
"Poland", "Polen",
"Portugal", "Portugal",
"Qatar", "Qatar",
"Romania", "Roumani&euml;",
"Russian-Federation", "Russische Federatie",
"Saudi-Arabia", "Saudi Arabi&euml;",
"San-Marino", "San Marino",
"Senegal", "Senegal",
"Sierra-Leone", "Sierra Leone",
"Sweden", "Sweden",
"Singapore", "Singapore",
"Slovenia", "Slovenia",
"Slovakia", "Slovakia",
"Swaziland", "Swaziland",
"Soviet-Union", "Sovjet Unie",
"El-Savaldor", "El Salvador",
"Chad", "Chad",
"Tanzania", "Tanzania",
"Togo", "Togo",
"Thailand", "Thailand",
"Tonga", "Tonga",
"Turkey", "Turkije",
"Taiwan", "Taiwan",
"Trinidad-and-Tobago", "Trinidad and Tobago",
"Turkmenistan", "Turkmenistan",
"Tunisia", "Tunisia",
"Ukraine", "Ukraine",
"Uganda", "Uganda",
"United-Kingdom", "Verenigd Koninkrijk",
"United-States", "Verenigde Staten",
"Uruguay", "Uruguay",
"Uzbekistan", "Uzbekistan",
"Vatican", "Vaticaan",
"Venezuela", "Venezuela",
"Vietnam", "Vietnam",
"Virgin-Islands-USA", "Virgin Eilanden (USA)",
"Virgin-Islands-UK", "Virgin Eilanden (Brits)",
"South-Africa", "Zuid Afrika",
"Yemen", "Yemen",
"Yugoslavia", "Yougoslavi&euml;",
"Zambia", "Zambia",
"Zimbabwe", "Zimbabwe",
"Norfolk-Island", "Norfolk Island",
"Netherlands-Antilles", "Nederlandse Antillen",
"American-Samoa", "Amerikaans Samoa",
"Mongolia", "Mongolia",
"Iraq", "Iraq",
"Vanuatu", "Vanuatu",
"Mali", "Mali",
"Rwanda", "Rwanda",
"Heard-and-McDonald-Islands", "Heard and McDonald Islands",
"Solomon-Islands", "Solomon Eilanden",
"Cocos-Islands", "Cocos Eilanden",
"Samoa", "Samoa",
"Mayotte", "Mayotte",
"Turks-and-Caicos-Islands","Turks en Caicos Eilanden",
"Saint-Pierre-et-Miquelon","Saint Pierre and Miquelon",
"Sierra-Leone", "Sierra Leone",
"South-Georgia-and-South-Sandwich-Islands","South Georgia en South Sandwich Eilanden",
"Jersey-Channel-Islands", "Jersey (Kanaal Eilanden)",
"Eritrea", "Eritrea",
"Tuvalu", "Tuvalu",
"Isle-of-Man", "Isle of Man",
"Laos", "Laos",
"Suriname", "Suriname",
"Montserrat", "Montserrat",
"Seychelles", "Seychellen",
"Grenada", "Grenada",
"Guernsey-Channel-Islands", "Guernsey (Kanaal Eilanden)",
"Saint-Helena", "Saint Helena",
"Papua-New-Guinea", "Papua New Guinea",
"Business", "Business",
"Cooperative", "Cooperative",
"Professional", "Professional",
"Name", "Name",
"Aeronautic", "Aeronautic",
"Info", "Info",
"Museum", "Museum",
"US-Minor-Outlying-Islands", "US Minor Outlying Islands",
"European-Union", "European Union",
"Saint-Kitts-Nevis-Anguilla", "Saint Kitts &amp; Nevis - Anguilla",
"Cape-Verde", "Cape Verde",
"Syria", "Syria",
"Haiti", "Haiti",
"Liberia", "Liberia",
"Libya", "Libya",
"North-Korea", "North Korea",
"Sudan", "Sudan",
"Palestine", "Palestine",
"Tadjikistan", "Tadjikistan",
"Saint-Vincent-Grenadines", "Saint Vincent &amp; Grenadines",
"Gambia", "Gambia",
"Equatorial-Guinea", "Equatorial Guinea",
"Kiribati", "Kiribati",
"Tokelau", "Tokelau",
"Local", "Local Network",
"Satellite", "Satellite",
"Falkland-Islands", "Falkland Islands",
"Myanmar", "Myanmar",
"Northern-Mariana-Islands", "Northern Mariana Islands",
"Malawi", "Malawi",
"Former-Czechoslovakia", "Former Czechoslovakia",
"Unknown", "Onbekend"
 );
