#!/bin/sh

#LC_ALL=uk_UK
#export LC_ALL
#LANG=uk_UK
#export LANG

day=`/bin/date +"%d"`
month=`/bin/date +"%m"`
year=`/bin/date +"%y"`
lettermonth=`/bin/date +"%b"`

PATH="/var/www/logs/"
entrylog=$PATH"accessnew"
tmp1=$PATH"zz"
tmp2=$PATH"zz2"
tmp3=$PATH"zz3"

gzipbin=/usr/bin/gzip
gunzipbin='/usr/bin/gzip -d' 
grepbin=/bin/grep
catbin=/bin/cat
rmbin=/bin/rm
sortbin=/bin/sort
separlog=$PATH"separ_log.pl"

echo "Date courante : $day $lettermonth $year"

#
# First day of the month test
#

day=`/usr/bin/expr $day - 1`

if [ "$day" = "0" ]
   then
      month=`/usr/bin/expr $month - 1`
   else
      month=`/usr/bin/expr $month - 0`
fi

if [ "$day" = "0" ]
then
if [ $month = "1" ] 
then day=31;lettermonth="Jan" 
fi
if [ $month = "2" ] 
then day=28;lettermonth="Feb" 
fi
if [ $month = "3" ] 
then day=31;lettermonth="Mar" 
fi
if [ $month = "4" ] 
then day=30;lettermonth="Apr" 
fi
if [ $month = "5" ] 
then day=31;lettermonth="May" 
fi
if [ $month = "6" ] 
then day=30;lettermonth="Jun" 
fi
if [ $month = "7" ] 
then day=31;lettermonth="Jul" 
fi
if [ $month = "8" ] 
then day=31;lettermonth="Aug" 
fi
if [ $month = "9" ] 
then day=30;lettermonth="Sep" 
fi
if [ $month = "10" ] 
then day=31;lettermonth="Oct" 
fi
if [ $month = "11" ] 
then day=30;lettermonth="Nov" 
fi
if [ $month = "12" ] 
then 
day=31;lettermonth="Dec" 
fi
fi

#
# First day of the year test
#

if [ "$month" = "0" ]
   then
      month=12;lettermonth="Dec";year=`/usr/bin/expr $year - 1`
if [ $year -lt 10 ]
	then
	year=0$year
	fi
fi

#
# add two digit for one digit month
#

if [ $month -lt 10 ]
   then
      month=0$month
fi

if [ $day -lt 10 ]
	then
	day=0$day
fi
	
# full year

year="20"$year

# calling scripts
#

currentlog=$PATH"access".$month-$year
currentloggzip=$currentlog."gz"

echo "Decompression du fichier courant $currentloggzip"
echo "$gunzipbin $currentloggzip"
$gunzipbin $currentloggzip
echo
echo "Tri sur $day/$lettermonth/$year ($entrylog vers $tmp1)"
echo "$grepbin \"$day/$lettermonth/$year\" $entrylog > $tmp1"
$grepbin "$day/$lettermonth/$year" $entrylog > $tmp1
echo
echo "Filtrage des images ($tmp1 vers $tmp2)"
echo "$separlog > $tmp2"
$separlog > $tmp2 
echo
echo "Concatenation de $currentlog avec $tmp2 vers $tmp3"
echo "$catbin $currentlog $tmp2 > $tmp3"
$catbin $currentlog $tmp2 > $tmp3
echo
echo "Tri du fichier $tmp3 vers $currentlog"
echo "$sortbin -t \"[\" -k 2,2.20 $tmp3 > $currentlog"
$sortbin -t "[" -k 2,2.20 $tmp3 > $currentlog
echo
echo "Efface les fichiers temporaires"
$rmbin $tmp1 
$rmbin $tmp2
$rmbin $tmp3
echo "Compression du fichier courant $currentlog"
echo "$gzipbin $currentlog"
$gzipbin $currentlog

